-- name=mg_attack_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_attack_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_porch" } );

  --------------------------------------------------------------------------------------------
  -- function win_catacombs_fear () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "win_attack_scr" ] = {
  --  type = "win",
  --  use_place = "gmg_graveyard_attack_scr",
  --  room = "rm_graveyard",
  --  zz_gate = "gmg_graveyard_catacombs_fear"
  --};   

  local win_attack_scr = function ()

    if ( cmn.IsEventDone( "win_attack_scr" ) ) then  

    else
      private.Match3Load();
    end;

  end;
  local win_attack_scr_loc = function ()

    if ( cmn.IsEventDone( "win_attack_scr" ) ) then  
    end;

  end;
 -- cmn.AddSubscriber( "win_attack_scr", win_attack_scr, private.room_objname );
 -- cmn.AddSubscriber( "win_attack_scr", win_attack_scr_loc, "rm_porch" );  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open () 

  cmn.StopMusEnv();
  common_impl.StopAllMus();
  cmn.PlayMusEnv( "mus_env/aud_danger_mus_env" );


  --if ( not cmn.IsEventDone( "win_attack_scr" ) ) then
    cmn.MiniGameShow();
    --common_impl.PassingMgStart();
  --end;

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
    private.Match3Init();

  common_impl.EnvPlay( { "levelext/env/aud_mg_fight_env" }, "", 0.5 );
  --common_impl.EnvPlay( { "level1/env/aud_porch_env" }, "", 0.5 );
  --if ( not cmn.IsEventStart( "win_attack_scr" ) ) then

    ng_global.progress[ "scr" ][ "win_attack_scr" ].enemy_energy = 125;
    ng_global.progress[ "scr" ][ "win_attack_scr" ].player_energy = -126;
    ng_global.progress[ "scr" ][ "win_attack_scr" ].bar_border = 227;
    ----==========================================================================
    ng_global.progress[ "scr" ][ "win_attack_scr" ].lockChips = {}
    for i = 1, private.match3_cell_y do
      ng_global.progress[ "scr" ][ "win_attack_scr" ].lockChips[ i ] = {};
      for j = 1, private.match3_cell_x do
        ng_global.progress[ "scr" ][ "win_attack_scr" ].lockChips[i][j] = false
      end;
    end;
    ----==========================================================================
    ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field = {};
    for i = 1, private.match3_cell_y do
      ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ] = {};
      for j = 1, private.match3_cell_x do
        ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] = 0;
      end;
    end;

    private.Match3GenerateField( );
    private.Match3Load();    
--  end;
  
end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  --common_impl.StopAudio( "env", "level1/env/aud_porch_env", 0.5 );
  --if ( not cmn.IsEventDone( "win_attack_scr" ) ) then
    cmn.MiniGameHide();
    --common_impl.PassingMgStop();
  --end;

end;
--*********************************************************************************************************************
-- function *** Skip/Reset *** () end;
--*********************************************************************************************************************
function public.Reset ()

  private.TotalReset( "yes" );

end;
--*********************************************************************************************************************
function public.Skip ()

  private.bar_border = 340; 
  private.enemy_energy = 239; 
  private.player_energy = -12;

  private.ResetEnergy( bar_border, enemy_energy, player_energy, "true" )

end;
--*********************************************************************************************************************
function private.TotalReset( answer )

  private.Match3GenerateField();

  if answer == "yes" then

    ng_global.progress[ "scr" ][ "win_attack_scr" ].enemy_energy = 125;
    ng_global.progress[ "scr" ][ "win_attack_scr" ].player_energy = -126;
    ng_global.progress[ "scr" ][ "win_attack_scr" ].bar_border = 227;

    private.enemy_energy = ng_global.progress[ "scr" ][ "win_attack_scr" ].enemy_energy;
    private.player_energy = ng_global.progress[ "scr" ][ "win_attack_scr" ].player_energy;
    private.bar_border = ng_global.progress[ "scr" ][ "win_attack_scr" ].bar_border; 

    private.ResetEnergy( private.bar_border, private.enemy_energy, private.player_energy, "false" )

    --==========================================================================
    for i = 1, private.match3_cell_y do
      for j = 1, private.match3_cell_x do
        ng_global.progress[ "scr" ][ "win_attack_scr" ].lockChips[i][j] = false;
        private.lockChips[i][j] = false;
      end;
    end;

    private.Match3LockAndUnLock();
    --==========================================================================
  end;


end;
--*********************************************************************************************************************
function private.ResetEnergy( bar_border, enemy_energy, player_energy, skip )

  local func_end = function ()
    cmn.Lock( false );
    if skip == "true" then private.Win(); end;
  end;

  cmn.Lock( true );

  ObjAnimate( "spr_attack_scr_enemy_energy", "pos_x", 0, 0, func_end, { 
    0.0, 0, ObjGet( "spr_attack_scr_enemy_energy" ).pos_x,  
    0.3, 0, private.enemy_energy,
  } ); 
  ObjAnimate( "spr_attack_scr_player_energy", "pos_x", 0, 0, "",{ 
    0.0, 0, ObjGet( "spr_attack_scr_player_energy" ).pos_x, 
    0.3, 0, private.player_energy,
  } ); 
  ObjAnimate( "spr_attack_scr_energy_bar_border", "pos_x", 0, 0, "",{ 
    0.0, 0, ObjGet( "spr_attack_scr_energy_bar_border" ).pos_x, 
    0.3, 0, private.bar_border,
  } ); 

end;
--*********************************************************************************************************************
-- function *** Win *** () end;
--*********************************************************************************************************************
function private.WinEnd ()

  --common_impl.PlayAudio( "sfx", "aud_mg_win" );
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_attack_scr" );
  cmn.CallEventHandler( "win_attack_scr" );
  levelscr.ExitMG();

end;
--*********************************************************************************************************************
function private.Win ()

  private.WinEnd();

end;
--*********************************************************************************************************************
-- function *** MG Match3 *** () end;
--*********************************************************************************************************************
function private.Match3Init ()

  private.match3 = {};

  private.match3_cell_x = 8;
  private.match3_cell_y = 5;

  private.match3_first_chip = nil;

  private.match3_toremove = {};
  private.match3_field    = {};
  private.match3_weidth   = {};

  private.delta_pos_y = 73;
  private.delta_pos_x = 73;
  private.start_pos_x = 274;
  private.start_pos_y = 241;

  private.chip_pos = { {}, {} };

  for j = 1, private.match3_cell_y do
    private.chip_pos[ 2 ][ j ] = private.start_pos_y + ( j - 1 ) * private.delta_pos_y;
  end;
  for j = 1, private.match3_cell_x do
    private.chip_pos[ 1 ][ j ] = private.start_pos_x + ( j - 1 ) * private.delta_pos_x;
  end;

  for i = 1, private.match3_cell_y do
    private.match3_field[ i ]  = { 0, 0, 0, 0, 0, 0, 0, 0 };
    private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0, 0 };
  end;

  private.enemy_energy = 125;
  private.player_energy = -126;
  private.bar_border = 227;
  private.temp_bar_border = 227;

  --============================================================================
  private.lockChips = {
    { false, false, false, false, false, false, false, false },
    { false, false, false, false, false, false, false, false },
    { false, false, false, false, false, false, false, false },
    { false, false, false, false, false, false, false, false },
    { false, false, false, false, false, false, false, false },
  }
  private.temp_unlock_chip = false;
  private.progress_save = 0;
  --============================================================================

end;
--*********************************************************************************************************************
function private.Match3Load ()

  for i = 1, private.match3_cell_y do
    for j = 1, private.match3_cell_x do

      ObjCreate( "obj_attack_scr_chip_"..i.."_"..j,             "obj" );
      ObjCreate( "spr_attack_scr_chip_"..i.."_"..j,             "spr" );
      ObjCreate( "anm_attack_scr_chip_flash_"..i.."_"..j,      "anim" );
      ObjCreate( "spr_attack_scr_chip_lock_"..i.."_"..j,        "spr" );
      ObjCreate( "pfx_attack_scr_chip_"..i.."_"..j,      "partsys_pm" );

      ObjAttach( "obj_attack_scr_chip_"..i.."_"..j,       "obj_attack_scr_game_field"       );
      ObjAttach( "anm_attack_scr_chip_flash_"..i.."_"..j, "obj_attack_scr_chip_"..i.."_"..j );
      ObjAttach( "spr_attack_scr_chip_"..i.."_"..j,       "obj_attack_scr_chip_"..i.."_"..j );
      ObjAttach( "spr_attack_scr_chip_lock_"..i.."_"..j,  "obj_attack_scr_chip_"..i.."_"..j );
      ObjAttach( "pfx_attack_scr_chip_"..i.."_"..j,       "obj_attack_scr_chip_"..i.."_"..j );

      local type = ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ];
      private.match3_field[ i ][ j ] = type;

      ObjSet( "obj_attack_scr_chip_"..i.."_"..j,{
        pos_x = private.start_pos_x + ( j - 1 ) * private.delta_pos_x,
        pos_y = private.start_pos_y + ( i - 1 ) * private.delta_pos_x,
        input   = true,
        active  = true,
        visible = true,
        event_mdown  = function () private.Match3ClickChip( "obj_attack_scr_chip_"..i.."_"..j ) end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
        inputrect_init = true,
        inputrect_x = -35,
        inputrect_y = -35,
        inputrect_w =  70,
        inputrect_h =  70,
      } );

      ObjSet( "spr_attack_scr_chip_"..i.."_"..j,{
        input = false,
        res = "assets/levels/levelext/mg_attack/layers/chip_"..type,
      } );
      ObjSet( "anm_attack_scr_chip_flash_"..i.."_"..j,{
        input = false,
        alp = 0,
        res = "assets/levels/levelext/mg_attack/anims/anm_circles",
        animfunc = "circle_"..type,
        playing = true,
      } );
      ObjSet( "spr_attack_scr_chip_lock_"..i.."_"..j,{
        input = false,
        visible = false,
        alp = 0;
        res = "assets/levels/levelext/mg_attack/layers/locked",
      } );
      ObjSet( "pfx_attack_scr_chip_"..i.."_"..j,{
        input = false,
        alp = 1;
        res = "",
      } );

    end;
  end;
  ---------------------------------------------------------------------------------------
    private.enemy_energy = ng_global.progress[ "scr" ][ "win_attack_scr" ].enemy_energy;
    private.player_energy = ng_global.progress[ "scr" ][ "win_attack_scr" ].player_energy;
    private.bar_border = ng_global.progress[ "scr" ][ "win_attack_scr" ].bar_border;

    ObjSet( "spr_attack_scr_enemy_energy",      { pos_x = private.enemy_energy  } )
    ObjSet( "spr_attack_scr_player_energy",     { pos_x = private.player_energy } )
    ObjSet( "spr_attack_scr_energy_bar_border", { pos_x = private.bar_border    } )

    for i = 1, private.match3_cell_y do
      for j = 1, private.match3_cell_x do
        private.lockChips[i][j] = ng_global.progress[ "scr" ][ "win_attack_scr" ].lockChips[i][j];
      end;
    end;

    private.Match3LockAndUnLock();
  ---------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function private.Match3GenerateField ( is_first )

  local is_done = false;

  for i = 1, private.match3_cell_y do
    for j = 1, private.match3_cell_x do

      local type = private.Match3GetRandomChip();
      ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] = type;

      if ( is_first ) then
        ObjCreate( "obj_attack_scr_chip_"..i.."_"..j,             "obj" );
        ObjCreate( "spr_attack_scr_chip_"..i.."_"..j,             "spr" );
        ObjCreate( "anm_attack_scr_chip_flash_"..i.."_"..j,      "anim" );
        ObjCreate( "spr_attack_scr_chip_lock_"..i.."_"..j,        "spr" );
        ObjCreate( "pfx_attack_scr_chip_"..i.."_"..j,      "partsys_pm" );

        ObjAttach( "obj_attack_scr_chip_"..i.."_"..j,       "obj_attack_scr_game_field"       );
        ObjAttach( "anm_attack_scr_chip_flash_"..i.."_"..j, "obj_attack_scr_chip_"..i.."_"..j );
        ObjAttach( "spr_attack_scr_chip_"..i.."_"..j,       "obj_attack_scr_chip_"..i.."_"..j );
        ObjAttach( "spr_attack_scr_chip_lock_"..i.."_"..j,  "obj_attack_scr_chip_"..i.."_"..j );
        ObjAttach( "pfx_attack_scr_chip_"..i.."_"..j,       "obj_attack_scr_chip_"..i.."_"..j );
      end;

    end;
  end;

  while ( not is_done ) do
    is_done = private.Match3ShuffleField();
  end;

  for i = 1, private.match3_cell_y do
    for j = 1,private.match3_cell_x do

      local type = ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ];

      ObjSet( "obj_attack_scr_chip_"..i.."_"..j,{
        pos_x = private.start_pos_x + ( j - 1 ) * private.delta_pos_x,
        pos_y = private.start_pos_y + ( i - 1 ) * private.delta_pos_x,
        input   = true,
        active  = true,
        visible = true,
        event_mdown  = function () private.Match3ClickChip( "obj_attack_scr_chip_"..i.."_"..j ) end,
        event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
        inputrect_init = true,
        inputrect_x = -35,
        inputrect_y = -35,
        inputrect_w =  70,
        inputrect_h =  70,
      } );

      ObjSet( "spr_attack_scr_chip_"..i.."_"..j,{
        input = false,
        res = "assets/levels/levelext/mg_attack/layers/chip_"..type,
      } );
      ObjSet( "anm_attack_scr_chip_flash_"..i.."_"..j,{
        input = false,
        alp = 0,
        res = "assets/levels/levelext/mg_attack/anims/anm_circles",
        animfunc = "circle_"..type,
        playing = true,
      } );
      ObjSet( "spr_attack_scr_chip_lock_"..i.."_"..j,{
        input = false,
        visible = false,
        alp = 0;
        res = "assets/levels/levelext/mg_attack/layers/locked",
      } );
      ObjSet( "pfx_attack_scr_chip_"..i.."_"..j,{
        input = false,
        alp = 1;
        res = "",
      } );

    end;
  end;

  if not private.Match3Path() then 
    private.TotalReset( "yes" );
  end;

end;
--*********************************************************************************************************************
function private.Match3ShuffleField ()

  local is_done = true;

  for i = 1, private.match3_cell_y do
    for j = 1, ( private.match3_cell_x - 2 ) do

      if ( ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] == ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 1 ] ) and
         ( ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] == ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 2 ] ) --then

        or ( ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] == 5  and
             ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 1 ] == ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 2 ] ) or 
           ( ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 1 ] == 5  and
             ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] == ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 2 ] ) or 
           ( ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 2 ] == 5  and
             ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] == ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 1 ] ) then

        ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j + 1 ] = private.Match3GetRandomChip();
        is_done = false;

      end;

    end;
  end;

  for i = 1, ( private.match3_cell_y - 2 ) do
    for j = 1, private.match3_cell_x do

      if ( ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] == ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i + 1 ][ j ] ) and
         ( ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] == ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i + 2 ][ j ] ) --then

        or ( private.match3_field[ i ][ j ] == 5  and
             private.match3_field[ i + 1 ][ j ] == private.match3_field[ i + 2 ][ j ] ) or 
           ( private.match3_field[ i + 1][ j ] == 5  and
             private.match3_field[ i ][ j ] == private.match3_field[ i + 2 ][ j ] ) or 
           ( private.match3_field[ i + 2 ][ j ] == 5  and
             private.match3_field[ i ][ j ] == private.match3_field[ i + 1 ][ j ] ) then

        ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i + 1 ][ j ] = private.Match3GetRandomChip();
        is_done = false;

      end;

    end;
  end;

  for i = 1, private.match3_cell_y do
    for j = 1, private.match3_cell_x do

      private.match3_field[ i ][ j ] = ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ];

    end;
  end;

  return is_done;

end;
--*********************************************************************************************************************
function private.Match3GetRandomChip ()

  local type = math.random( 1, 100 );

  if     ( type > 0  and type < 2  ) then type = 5;
  elseif ( type > 2  and type < 32 ) then type = 4;
  elseif ( type > 32 and type < 62 ) then type = 3;
  elseif ( type > 62 and type < 82 ) then type = 2;
  else                                    type = 1;
  end;
  return type;
  
end;
--*********************************************************************************************************************
function private.Match3ClickChip ( chip )

  --common_impl.PlayAudio( "sfx", "common/audio/aud_clk_element", 0, "", 0 );

  if ( not private.match3_first_chip ) then

    private.match3_first_chip = chip;
    local pos = ObjGet( chip );

    ObjSet( "anm"..string.sub( private.match3_first_chip, 4, 20 ).."flash_"..string.sub( private.match3_first_chip, -3 ),{ alp = 1 } );

  else

    ObjSet( "anm"..string.sub( private.match3_first_chip, 4, 20 ).."flash_"..string.sub( private.match3_first_chip, -3 ), { alp = 0 } );

    if ( private.match3_first_chip == chip ) then
      private.match3_first_chip = nil;
      return;
    end;

    private.match3_second_chip = chip;

    local old_x = ObjGet( private.match3_first_chip ).pos_x;
    local old_y = ObjGet( private.match3_first_chip ).pos_y;
    local new_x = ObjGet( chip ).pos_x;
    local new_y = ObjGet( chip ).pos_y;

    local old_i_x = 0;
    local old_i_y = 0;
    local new_i_x = 0;
    local new_i_y = 0;

    for i = 1, private.match3_cell_x do
      if ( old_x == private.chip_pos[ 1 ][ i ] ) then old_i_y = i; end;
      if ( new_x == private.chip_pos[ 1 ][ i ] ) then new_i_y = i; end;
    end;

    for i = 1, private.match3_cell_y do
      if ( old_y == private.chip_pos[ 2 ][ i ] ) then old_i_x = i; end;
      if ( new_y == private.chip_pos[ 2 ][ i ] ) then new_i_x = i; end;
    end;

    if ( old_i_x == new_i_x ) and ( math.abs( old_i_y - new_i_y ) == 1 ) or
       ( old_i_y == new_i_y ) and ( math.abs( old_i_x - new_i_x ) == 1 ) then

      private.Match3SwapChips( new_x, new_y, old_x, old_y );

      local temp = private.match3_field[ old_i_x ][ old_i_y ];

      private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
      private.match3_field[ new_i_x ][ new_i_y ] = temp;

      if ( private.Match3Checking() ) then

        ObjSet( "tmr_attack_scr_exchange", {
          time = 0.201, 
          playing = true,
          endtrig = function ()
            private.Match3SetFieldState();
            private.Match3Disappearance();
          end;
        } );

      else

        local temp = private.match3_field[ old_i_x ][ old_i_y ];

        private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
        private.match3_field[ new_i_x ][ new_i_y ] = temp; 

        ObjSet( "tmr_attack_scr_exchange", {
          time = 0.201, 
          playing = true,
          endtrig = function () private.Match3SwapChips( old_x, old_y, new_x, new_y, true ); end;
        } );

      end;

      private.match3_firstclk = nil;

    else

      private.match3_first_chip = chip;
      local pos = ObjGet( chip );
      ObjSet( "anm"..string.sub( private.match3_first_chip, 4, 20 ).."flash_"..string.sub( private.match3_first_chip, -3 ),{ alp = 1 } );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Match3SwapChips ( new_x, new_y, old_x, old_y, is_back )

  common_impl.Lock( true );
  --common_impl.PlayAudio( "sfx", "common/audio/aud_changeelement_1", 0, "", 0 );

  ObjAnimate( private.match3_second_chip, "pos_xy", 0, 0,
  function ()
    if ( is_back ) then
      private.match3_first_chip = nil;
      common_impl.Lock( false );
    end;
  end,
  {
    0.0, 0, new_x, new_y,
    0.2, 0, old_x, old_y
  } );

  ObjAnimate( private.match3_first_chip, "pos_xy", 0, 0, "",{
    0.0, 0, old_x, old_y,
    0.2, 0, new_x, new_y
  } );

end;
--*********************************************************************************************************************
function private.Match3Checking ()

  for i = 1, private.match3_cell_y do
    for j = 1, ( private.match3_cell_x - 2 ) do

      if ( ( private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 1 ] and 
             private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 2 ]     ) or 
           ( private.match3_field[ i ][ j ] == 5                                  and 
             private.match3_field[ i ][ j + 1 ] == private.match3_field[ i ][ j + 2 ] ) or 
           ( private.match3_field[ i ][ j + 1 ] == 5                              and 
             private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 2 ]     ) or 
           ( private.match3_field[ i ][ j + 2 ] == 5                              and 
             private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 1 ]     )
         ) 
        and private.lockChips[i][j+1] == false 
        then
        ------------------------------------------------------------------------------------------
        if private.match3_field[ i ][ j ] == 1 or private.match3_field[ i ][ j ] == 2 or
           private.match3_field[ i ][ j+1 ] == 1 or private.match3_field[ i ][ j+1 ] == 2 or
           private.match3_field[ i ][ j+2 ] == 1 or private.match3_field[ i ][ j+2 ] == 2 then

          private.Match3EnergyBarHelper( "enemy" )

        else
           
          private.Match3EnergyBarHelper( "player" )

        end;
        ------------------------------------------------------------------------------------------
        if ( private.lockChips[i][j] == false ) then
          if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j,     0 }; end;
        else
          private.Match3UnLock( i, j )
        end;

        if ( private.lockChips[i][j+1] == false ) then
          if ( private.Match3AddToQueue( i, j + 1 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 1, 0 }; end;
        end;

        if ( private.lockChips[i][j+2] == false ) then
          if ( private.Match3AddToQueue( i, j + 2 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 2, 0 }; end;
        else
          private.Match3UnLock( i, j+2 )
        end;

      end;

    end;
  end;

  for i = 1, ( private.match3_cell_y - 2 ) do
    for j = 1, private.match3_cell_x do

      if ( ( private.match3_field[ i ][ j ] == private.match3_field[ i + 1 ][ j ] and 
             private.match3_field[ i ][ j ] == private.match3_field[ i + 2 ][ j ]     ) or 
           ( private.match3_field[ i ][ j ] == 5                                  and 
             private.match3_field[ i + 1 ][ j ] == private.match3_field[ i + 2 ][ j ] ) or 
           ( private.match3_field[ i + 1][ j ] == 5                               and 
             private.match3_field[ i ][ j ] == private.match3_field[ i + 2 ][ j ]     ) or 
           ( private.match3_field[ i + 2 ][ j ] == 5                              and 
             private.match3_field[ i ][ j ] == private.match3_field[ i + 1 ][ j ]    )  --then
         ) 
        and private.lockChips[i+1][j] == false 
        then
        ------------------------------------------------------------------------------------------
        if private.match3_field[ i ][ j ] == 1 or private.match3_field[ i ][ j ] == 2 or
           private.match3_field[ i+1 ][ j ] == 1 or private.match3_field[ i ][ j ] == 2 or
           private.match3_field[ i+1 ][ j ] == 1 or private.match3_field[ i ][ j ] == 2 then

          private.Match3EnergyBarHelper( "enemy" )

        else
           
          private.Match3EnergyBarHelper( "player" )

        end;
        ------------------------------------------------------------------------------------------
        if ( private.lockChips[i][j] == false ) then
          if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i,     j, math.pi / 2 }; end;
        else
          private.Match3UnLock( i, j )
        end;

        if ( private.lockChips[i+1][j] == false ) then
          if ( private.Match3AddToQueue( i + 1, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 1, j, math.pi / 2 }; end;
        end;

        if ( private.lockChips[i+2][j] == false ) then
          if ( private.Match3AddToQueue( i + 2, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 2, j, math.pi / 2 }; end;
        else
          private.Match3UnLock( i+2, j )
        end;

      end;

    end;
  end;

  if ( #private.match3_toremove == 0 ) then return false; end;

  return true;

end;
--*********************************************************************************************************************
function private.Match3AddToQueue ( pos_x, pos_y )

  for i = 1, #private.match3_toremove do

    if ( private.match3_toremove[ i ][ 1 ] == pos_x ) and
       ( private.match3_toremove[ i ][ 2 ] == pos_y ) then
      return false;
    end;

  end;
  return true;

end;
--*********************************************************************************************************************
function private.Match3SetFieldState ()

  for i = 1, private.match3_cell_y do
    for j = 1, private.match3_cell_x do

      local type = private.match3_field[ i ][ j ];

      ObjSet( "obj_attack_scr_chip_"..i.."_"..j,
      {
        pos_x = private.chip_pos[ 1 ][ j ],
        pos_y = private.chip_pos[ 2 ][ i ],
      } );
      ObjSet( "spr_attack_scr_chip_"..i.."_"..j,
      {
        res = "assets/levels/levelext/mg_attack/layers/chip_"..type,
      } );
      ObjSet( "anm_attack_scr_chip_flash_"..i.."_"..j,
      {
        input = false,
        alp = 0,
        res = "assets/levels/levelext/mg_attack/anims/anm_circles",
        animfunc = "circle_"..type,
        playing = true,
      } );
    end;
  end;

  if not private.Match3Path() then 
    private.TotalReset( "yes" );
  end;

end;
--*********************************************************************************************************************
function private.Match3Disappearance ()

  common_impl.Lock( true );

  if ( #private.match3_toremove ~= 0 ) then

    --common_impl.PlayAudio( "sfx", "common/audio/aud_explodeelements", 0, "", 0 );

    for i = 1, ( #private.match3_toremove ) do

      local x = private.match3_toremove[ i ][ 1 ];
      local y = private.match3_toremove[ i ][ 2 ];
      local a = private.match3_toremove[ i ][ 3 ];

      ObjAnimate( "spr_attack_scr_chip_"..x.."_"..y, "alp", 0, 0, "",{
        0.0, 0, 1,
        0.3, 0, 0
      } );
      ObjAnimate( "anm_attack_scr_chip_flash_"..x.."_"..y, "alp", 0, 0, "",{
        0.00, 0, 0,
        0.15, 0, 1,
        0.30, 0, 0
      } );

      if private.match3_field[ x ][ y ] == 1 or private.match3_field[ x ][ y ] == 2 then
        ObjSet( "pfx_attack_scr_chip_"..x.."_"..y,{
          input = false, alp = 1;
          res = "assets/levels/levelext/mg_attack/anims/fx_sparkle_2",
        } );
      else
        ObjSet( "pfx_attack_scr_chip_"..x.."_"..y,{
          input = false, alp = 1;
          res = "assets/levels/levelext/mg_attack/anims/fx_sparkle_1",
        } );
      end;

      private.match3_field[ private.match3_toremove[ i ][ 1 ] ][ private.match3_toremove[ i ][ 2 ] ] = 0;

      private.Match3FindUnLock( x, y );

    end;

    ObjSet( "tmr_attack_scr_remove", {
      time = 0.301, 
      playing = true,
      endtrig = function ()
        private.Match3FallChips();
      end;
    } );

  end;

end;
--*********************************************************************************************************************
function private.Match3FallChips ()

  for i = 1, 5 do
    for j = 1,8 do
      ObjSet( "pfx_attack_scr_chip_"..i.."_"..j,{ input = false, alp = 1; res = "" } );
    end;
  end;

  --common_impl.PlayAudio( "sfx", "common/audio/aud_elementsfall", 0, "", 0 );
  for j = private.match3_cell_x, 1, -1 do
    for i = private.match3_cell_y, 1, -1 do

      if ( private.match3_field[ i ][ j ] == 0 ) then

        local index = i;

        while ( index > 0 ) do
          if ( private.match3_field[ index ][ j ] ~= 0 ) then
            private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] + 1;
          else
            private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] - 1;
          end;
          index = index - 1;
        end;

      end;

    end;
  end;

  for j = private.match3_cell_x, 1, -1 do
    local count = 0;
    for i = private.match3_cell_y, 1, -1 do

      local pos = private.match3_weidth[ i ][ j ];

      if ( pos < 0 ) then
        local chip = "obj_matchthree_chip_"..i.."_"..j;
        ObjSet( chip, { pos_y = ( 51 * pos - private.delta_pos_y ), --[[pos_x = private.start_pos_x]] } );
      end;

    end;
  end;

  for i = private.match3_cell_y, 1, -1 do
    for j = private.match3_cell_x, 1, -1 do

      if ( private.match3_weidth[ i ][ j ] > 0 ) then

        local chip = "obj_attack_scr_chip_"..i.."_"..j;
        local pos_start = private.chip_pos[ 2 ][ i ];
        local pos_end   = pos_start + 51 * private.match3_weidth[ i ][ j ];

        ObjAnimate( chip, "pos_y", 0, 0, "",{
          0.0, 1, pos_start,
          0.3, 1, pos_end
        } );

        private.match3_field[ i + private.match3_weidth[ i ][ j ] ][ j ] = private.match3_field[ i ][ j ];
        private.match3_field[ i ][ j ] = 0;
        private.lockChips[ i + private.match3_weidth[ i ][ j ] ][ j ] = private.lockChips[ i ][ j ];
        private.lockChips[ i ][ j ] = false;

      end;

    end;
  end;

  for i = 1, private.match3_cell_y do
    for j = 1, private.match3_cell_x do

      if ( private.match3_field[ i ][ j ] == 0 ) then

        private.match3_field[ i ][ j ] = private.Match3GetRandomChip();

        local x = 0;
        local y = 0;
        local loop = true;

        for i = 1, private.match3_cell_y do

          if ( loop ) then

            for j = 1, private.match3_cell_x do

              if ( private.match3_weidth[ i ][ j ] < 0 ) then
                x = i;
                y = j;
                private.match3_weidth[ i ][ j ] = 0;
                loop = false;
                break;
              end;

            end;

          end;

        end;

        local chip = "obj_attack_scr_chip_"..x.."_"..y;
        local pos_y = -100

        ObjSet( "spr_attack_scr_chip_"..x.."_"..y, { alp = 1, res = "assets/levels/levelext/mg_attack/layers/chip_"..private.match3_field[ i ][ j ], } );
        ObjAnimate( chip, "pos_y", 0, 0, "",{
          0.00, 1, pos_y, 
          0.30, 1, private.chip_pos[ 2 ][ i ],
        } );

      end;

    end;
  end;

  private.match3_toremove = {};
  private.match3_grain = {};

  for i = 1, private.match3_cell_y do 
    private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0, 0 };
  end;

  private.Match3EnergyBar();

  ObjSet( "tmr_attack_scr_fall", 
  {
    time = 0.301, 
    playing = true,
    endtrig = function ()

      private.Match3SetFieldState();
      private.Match3LockAndUnLock();

      local is_delete_chips = private.Match3Checking();

      if ( is_delete_chips ) then
        private.Match3Disappearance();
      else 
        private.Match3FallChipsEnd();
      end;

    end;
  } );

end;
--*********************************************************************************************************************
function private.Match3FallChipsEnd ()

  if private.bar_border > private.temp_bar_border then
    private.Match3Attack();
  else
    private.Match3Save();
  end;
  private.temp_bar_border = private.bar_border;

  common_impl.Lock( false );

  private.match3_first_chip = nil;

  if ( private.Match3CheckWin() ) then
    private.Win();
  else

    for i = 1, private.match3_cell_y do
      for j = 1, private.match3_cell_x do
        ng_global.progress[ "scr" ][ "win_attack_scr" ].match3_field[ i ][ j ] = private.match3_field[ i ][ j ];
        ng_global.progress[ "scr" ][ "win_attack_scr" ].lockChips[i][j] = private.lockChips[i][j];
      end;
    end;
    ng_global.progress[ "scr" ][ "win_attack_scr" ].enemy_energy = private.enemy_energy;
    ng_global.progress[ "scr" ][ "win_attack_scr" ].player_energy = private.player_energy;
    ng_global.progress[ "scr" ][ "win_attack_scr" ].bar_border = private.bar_border;

  end;

end;
--*********************************************************************************************************************
function private.Match3CheckWin()

  if private.bar_border >339 then
    return true;
  elseif private.bar_border < 111 then
    public.Reset();
  else
    return false;
  end;

end;
--*********************************************************************************************************************
-- function *** EnergyBar *** () end;
--*********************************************************************************************************************
function private.Match3EnergyBarHelper( name )

  if name == "enemy" then 
    private.enemy_energy = private.enemy_energy - 5
    private.player_energy = private.player_energy - 5
    private.bar_border = private.bar_border - 5
  end;

  if name == "player" then 
    private.enemy_energy = private.enemy_energy + 5
    private.player_energy = private.player_energy + 5
    private.bar_border = private.bar_border + 5
  end;

end;
--*********************************************************************************************************************
function private.Match3EnergyBar()

  if private.bar_border < 111 then private.bar_border = 110; private.enemy_energy = 12;  private.player_energy = -238; end;
  if private.bar_border > 339 then private.bar_border = 340; private.enemy_energy = 239; private.player_energy = -12;  end;

  private.ResetEnergy( private.bar_border, private.enemy_energy, private.player_energy, "false" )

end;
--*********************************************************************************************************************
-- function *** Lock/UnLock *** () end;
--*********************************************************************************************************************
function private.Match3LockAndUnLock()

  for i = 1,5 do
    for j = 1,8 do
      if private.lockChips[i][j] == true then
        ObjSet( "spr_attack_scr_chip_lock_"..i.."_"..j,{ alp = 1, visible = true  } );
        ObjSet( "obj_attack_scr_chip_"..i.."_"..j,     {            input = false } );
      else
        ObjSet( "spr_attack_scr_chip_lock_"..i.."_"..j,{ alp = 0, visible = false } );
        ObjSet( "obj_attack_scr_chip_"..i.."_"..j,     {            input = true  } );
      end;
    end;
  end;

end;
--*********************************************************************************************************************
function private.Match3LockChipRandom()

  local position_x = math.random( 1, 5 );
  local position_y = math.random( 1, 8 );

  private.Match3LockChip( position_x, position_y );

end;
--*********************************************************************************************************************
function private.Match3LockChip( position_x, position_y )

  if ( private.lockChips[position_x][position_y] == false ) then

    local func_end = function ()

      cmn.Lock( false );
      ObjSet( "spr_attack_scr_chip_lock_"..position_x.."_"..position_y,{ alp = 1, visible = true  } );
      ObjSet( "obj_attack_scr_chip_"..position_x.."_"..position_y,     {            input = false } );
      private.lockChips[position_x][position_y] = true;

      for i = 1, private.match3_cell_y do
        for j = 1, private.match3_cell_x do
          ng_global.progress[ "scr" ][ "win_attack_scr" ].lockChips[i][j] = private.lockChips[i][j];
        end;
      end;

      if not private.Match3Path() then 
        private.TotalReset( "yes" );
      end;

    end;

    cmn.Lock( true );
    ObjSet( "spr_attack_scr_chip_lock_"..position_x.."_"..position_y,{ visible = true } );
    ObjAnimate( "spr_attack_scr_chip_lock_"..position_x.."_"..position_y, "alp", 0, 0, func_end, { 
      0.0, 0, ObjGet( "spr_attack_scr_enemy_energy" ).alp,  
      0.3, 0, 1,
    } ); 

  else private.Match3LockChipRandom();
  end;

end;
--*********************************************************************************************************************
function private.Match3FindUnLock( width, height )

  for i = width-1, width+1 do
    for j = height-1, height+1 do

      if ( i>0 and i<6 and j>0 and j<9 ) then
        if private.lockChips[ i ][ j ] == true then 
          private.Match3UnLock( i, j ); 
        end;
      end;

    end;
  end;

end;
--*********************************************************************************************************************
function private.Match3UnLock( position_x, position_y )

  --  local func_end = function ()
  --
  --    cmn.Lock( false );

    ObjSet( "spr_attack_scr_chip_lock_"..position_x.."_"..position_y,{ alp = 0, visible = false} );
    ObjSet( "obj_attack_scr_chip_"..position_x.."_"..position_y,     {            input = true } );
    
    private.lockChips[position_x][position_y] = false;

  --  end;
  --
  --  cmn.Lock( true );
  --ObjAnimate( "spr_attack_scr_chip_lock_"..position_x.."_"..position_y, "alp", 0, 0, func_end, { 
  --  0.0, 0, ObjGet( "spr_attack_scr_enemy_energy" ).alp,  
  --  0.3, 0, 0,
  --} ); 

  ObjAnimate( "spr_attack_scr_chip_lock_"..position_x.."_"..position_y, "alp", 0, 0, "", { 
    0.0, 0, ObjGet( "spr_attack_scr_enemy_energy" ).alp,  
    0.3, 0, 0,
  } ); 

end;
----*******************************************************************************************************************
----*** function *** Find Path *** () end; ****************************************************************************
----*******************************************************************************************************************
function private.Match3Path()

  local is_done = false;

  -- positions: { {second chip},{ third chip },{ where to move first chip }}
  local shift = { { { -1,  1 }, {  1,  1 },   {  0,  1  } },
                  { { -1,  1 }, {  1,  0 },   { -1,  0  } },
                  { { -1,  1 }, { -1,  2 },   { -1,  0  } },
                  { { -1,  1 }, { -2,  1 },   {  0,  1  } },
                  { { -1,  1 }, { -2,  0 },   { -1,  0  } },
                  { { -1,  1 }, { -1, -1 },   { -1,  0  } },

                  { {  1,  1 }, {  1,  2 },   {  1,  0  } },
                  { {  1,  1 }, {  2,  1 },   {  0,  1  } },
                  { {  1,  1 }, {  2,  0 },   {  1,  0  } },
                  { {  1,  1 }, {  1, -1 },   {  1,  0  } },
                  { {  1,  1 }, { -1,  0 },   {  1,  0  } },
                  { {  1,  1 }, { -1,  1 },   {  0,  1  } },

                  { { -1, -1 }, {  0,  1 },   {  0, -1  } },
                  { { -1, -1 }, {  1,  0 },   { -1,  0  } },
                  { { -1, -1 }, {  1, -1 },   {  0, -1  } },
                  { { -1, -1 }, {  0, -2 },   {  0, -1  } },
                  { { -1, -1 }, { -2,  0 },   { -1,  0  } },
                  { { -1, -1 }, { -2, -1 },   {  0, -1  } },

                  { {  1, -1 }, {  2,  0 },   {  1,  0  } },
                  { {  1, -1 }, {  2, -1 },   {  0, -1  } },
                  { {  1, -1 }, {  0, -2 },   {  0, -1  } },
                  { {  1, -1 }, { -1, -1 },   {  0, -1  } },
                  { {  1, -1 }, { -1,  0 },   {  1,  0  } },
                  { {  1, -1 }, {  0,  1 },   {  0, -1  } },

                  { {  0,  1 }, { -1,  2 },   {  0,  2  } },
                  { {  0,  1 }, {  1,  2 },   {  0,  2  } },
                  { {  0,  1 }, {  0,  3 },   {  0,  2  } },
                  { {  0,  1 }, { -1, -1 },   {  0, -1  } },
                  { {  0,  1 }, {  1, -1 },   {  0, -1  } },
                  { {  0,  1 }, {  0, -2 },   {  0, -1  } },

                  { {  0, -1 }, { -1, -2 },   {  0, -2  } },
                  { {  0, -1 }, {  1, -2 },   {  0, -2  } },
                  { {  0, -1 }, {  0, -3 },   {  0, -2  } },
                  { {  0, -1 }, { -1,  1 },   {  0,  1  } },
                  { {  0, -1 }, {  1,  1 },   {  0,  1  } },
                  { {  0, -1 }, {  0,  2 },   {  0,  1  } },

                  { {  1,  0 }, { -1,  1 },   { -1,  0  } },
                  { {  1,  0 }, { -1, -1 },   { -1,  0  } },
                  { {  1,  0 }, { -2,  0 },   { -1,  0  } },
                  { {  1,  0 }, {  2,  1 },   {  2,  0  } },
                  { {  1,  0 }, {  2, -1 },   {  2,  0  } },
                  { {  1,  0 }, {  3,  0 },   {  2,  0  } },

                  { { -1,  0 }, {  1,  1 },   {  1,  0  } },
                  { { -1,  0 }, {  1, -1 },   {  1,  0  } },
                  { { -1,  0 }, {  2,  0 },   {  1,  0  } },
                  { { -1,  0 }, { -3,  0 },   { -2,  0  } },
                  { { -1,  0 }, { -2,  1 },   { -2,  0  } },
                  { { -1,  0 }, { -2, -1 },   { -2,  0  } },
                }; 

  for i = 1, private.match3_cell_y do
    for j = 1, private.match3_cell_x do
      for c = 1, #shift do

        local cell_1_i = i;
        local cell_1_j = j;
        local cell_2_i = i + shift[ c ][ 1 ][ 1 ];
        local cell_2_j = j + shift[ c ][ 1 ][ 2 ];
        local cell_3_i = i + shift[ c ][ 2 ][ 1 ];
        local cell_3_j = j + shift[ c ][ 2 ][ 2 ];
        local cell_lock_i = i + shift[ c ][ 3 ][ 1 ];
        local cell_lock_j = j + shift[ c ][ 3 ][ 2 ];

        if ( cell_1_i > 0 )    and ( cell_1_j > 0 )    and
           ( cell_2_i > 0 )    and ( cell_2_j > 0 )    and
           ( cell_3_i > 0 )    and ( cell_3_j > 0 )    and
           ( cell_lock_i > 0 ) and ( cell_lock_j > 0 ) and
           ( cell_1_i <= private.match3_cell_y )    and ( cell_1_j <= private.match3_cell_x )    and
           ( cell_2_i <= private.match3_cell_y )    and ( cell_2_j <= private.match3_cell_x )    and
           ( cell_3_i <= private.match3_cell_y )    and ( cell_3_j <= private.match3_cell_x )    and
           ( cell_lock_i <= private.match3_cell_y ) and ( cell_lock_j <= private.match3_cell_x ) and
             private.lockChips[ cell_lock_i ][ cell_lock_j ] == false
        then

          local chip_1 = private.match3_field[ cell_1_i ][ cell_1_j ];
          local chip_2 = private.match3_field[ cell_2_i ][ cell_2_j ];
          local chip_3 = private.match3_field[ cell_3_i ][ cell_3_j ];

          local chip_1_lock = private.lockChips[ cell_1_i ][ cell_1_j ];
          local chip_2_lock = private.lockChips[ cell_2_i ][ cell_2_j ];
          local chip_3_lock = private.lockChips[ cell_3_i ][ cell_3_j ];

          if ( chip_1 == chip_2 and chip_1_lock == false and chip_2_lock == false ) and 
             ( chip_1 == chip_3 and chip_1_lock == false and chip_3_lock == false ) then

            is_done = true;
            break;

          end;

        end;

      end;
    end;
  end;

  return is_done;

end;
--*********************************************************************************************************************
-- function *** Anims *** () end;
--*********************************************************************************************************************
function private.Match3Attack()

  local func_end = function()
 
    ObjMultiSet({ 
      { "anm_attack_scr_player_stronger", { alp = 0                 }},
      { "anm_attack_scr_static_fight",    { alp = 1, playing = true }},
    });
    --DbgTrace( "attack_scr" );

  end;

  ObjMultiSet({ 
    { "anm_attack_scr_player_stronger", { alp = 1 }},
    { "anm_attack_scr_static_fight",    { alp = 0 }},
  });

  AnimPlay( "anm_attack_scr_player_stronger", "player_stronger", func_end )

end;
--*********************************************************************************************************************
function private.Match3Save()

  local func_end = function()

    ObjMultiSet({ 
      { "anm_attack_scr_enemy_stronger", { alp = 0                 }},
      { "anm_attack_scr_static_fight",   { alp = 1, playing = true }},
    });

    private.progress_save = private.progress_save + 1;
    --DbgTrace( "Save" );

    if private.progress_save > 1 then
      private.Match3LockChipRandom();
      private.progress_save = 0;
    end;

  end;

  ObjMultiSet({ 
    { "anm_attack_scr_enemy_stronger", { alp = 1 }},
    { "anm_attack_scr_static_fight",   { alp = 0 }},
  });

  AnimPlay( "anm_attack_scr_enemy_stronger", "enemy_stronger", func_end )

end;
--*********************************************************************************************************************