-- name=rm_extra
--******************************************************************************************
function public.Init()

  ObjSet( "btn_extra_wallpapers", 
    {
      event_mdown =  function () private.ShowScreen( "wallpapers" ); end,
      event_menter = function () private.ButtonMouseEnter( "wallpapers" ); private.ButtonMouseEnterAdd( "wallpapers" ); end,
      event_mleave = function () private.ButtonMouseLeave( "wallpapers" ); private.ButtonMouseLeaveAdd( "wallpapers" ); end
    } 
  );

  ObjSet( "btn_extra_conceptart", 
    {
      event_mdown =  function () private.ShowScreen( "conceptart" ); end,
      event_menter = function () private.ButtonMouseEnter( "conceptart" ); private.ButtonMouseEnterAdd( "conceptart" ); end,
      event_mleave = function () private.ButtonMouseLeave( "conceptart" ); private.ButtonMouseLeaveAdd( "conceptart" ); end
    } 
  );

  ObjSet( "btn_extra_music", 
    {
      event_mdown =  function () private.ShowScreen( "music" ); end,
      event_menter = function () private.ButtonMouseEnter( "music" ); private.ButtonMouseEnterAdd( "music" ); end,
      event_mleave = function () private.ButtonMouseLeave( "music" ); private.ButtonMouseLeaveAdd( "music" ); end
    } 
  );

  ObjSet( "btn_extra_bonus_chapter", 
    {
      event_mdown =  function () private.ShowScreen( "bonus_chapter" ); end,
      event_menter = function () private.ButtonMouseEnter( "bonus_chapter" ); end,
      event_mleave = function () private.ButtonMouseLeave( "bonus_chapter" ); end
    } 
  );
  
  ObjSet( "btn_extra_mainmenu", 
    {
      event_mdown =  function () common.GotoRoom( "rm_menu" ); end,
      event_menter = function () private.ButtonMouseEnter( "mainmenu" ); end,
      event_mleave = function () private.ButtonMouseLeave( "mainmenu" ); end
    } 
  );
  
  ObjSet( "btn_extra_achievements", 
    {
      event_mdown =  function () common.GotoRoom( "rm_achievements" ); end,
      event_menter = function () private.ButtonMouseEnter( "achievements" ); private.ButtonMouseEnterAdd( "achievements" ); end,
      event_mleave = function () private.ButtonMouseLeave( "achievements" ); private.ButtonMouseLeaveAdd( "achievements" ); end
    } 
  );
  
  ObjSet( "btn_extra_collectibles", 
    {
      event_mdown =  function () common.GotoRoom( "rm_collectibles" ); end,
      event_menter = function () private.ButtonMouseEnter( "collectibles" ); private.ButtonMouseEnterAdd( "collectibles" ); end,
      event_mleave = function () private.ButtonMouseLeave( "collectibles" ); private.ButtonMouseLeaveAdd( "collectibles" ); end
    } 
  );
  ObjSet( "btn_extra_collectibles_2", 
    {
      event_mdown =  function () common.GotoRoom( "rm_collectibles2" ); end,
      event_menter = function () private.ButtonMouseEnter( "collectibles_2" ); private.ButtonMouseEnterAdd( "collectibles_2" ); end,
      event_mleave = function () private.ButtonMouseLeave( "collectibles_2" ); private.ButtonMouseLeaveAdd( "collectibles_2" ); end
    } 
  );
  ObjSet( "btn_extra_change_lft", 
    {
      event_mdown =  function () private.ArrowClick( true ) end,
      event_menter = function () private.ButtonMouseEnter( "change_lft" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_lft" ); end
    } 
  );
  ObjSet( "btn_extra_change_rgt", 
    {
      event_mdown =  function () private.ArrowClick( false ) end,
      event_menter = function () private.ButtonMouseEnter( "change_rgt" ); end,
      event_mleave = function () private.ButtonMouseLeave( "change_rgt" ); end
    } 
  );

  ObjSet( "btn_extra_play", 
    {
      event_mdown =  function () private.ButtonSetClick() end,
      event_menter = function () private.ButtonMouseEnter( "play" ); end,
      event_mleave = function () private.ButtonMouseLeave( "play" ); end
    } 
  );

  ObjSet( "btn_extra_set", 
    {
      event_mdown =  function () private.ButtonSetClick() end,
      event_menter = function () private.ButtonMouseEnter( "set" ); end,
      event_mleave = function () private.ButtonMouseLeave( "set" ); end
    } 
  );

  ObjSet( "btn_extra_save", 
    {
      event_mdown =  function () private.ButtonSetClick() end,
      event_menter = function () private.ButtonMouseEnter( "save" ); end,
      event_mleave = function () private.ButtonMouseLeave( "save" ); end
    } 
  );

  ObjSet( "btn_extra_secretroom", 
    {
      event_mdown =  function () private.SecretRoomPlay() end,
      event_menter = function () private.ButtonMouseEnter( "secretroom" ) private.ButtonMouseEnterAdd( "secretroom" ) end,
      event_mleave = function () private.ButtonMouseLeave( "secretroom" ) private.ButtonMouseLeaveAdd( "secretroom" ) end
    } 
  );

  ObjSet( "btn_extra_replayho", 
    {
      event_mdown =  function () private.ShowScreen( "replayho" ) end, 
      event_menter = function () private.ButtonMouseEnter( "replayho" ) private.ButtonMouseEnterAdd( "replayho" ) end,
      event_mleave = function () private.ButtonMouseLeave( "replayho" ) private.ButtonMouseLeaveAdd( "replayho" ) end
    } 
  );

  ObjSet( "btn_extra_replaymg", 
    {
      event_mdown =  function () private.ShowScreen( "replaymg" ) end, 
      event_menter = function () private.ButtonMouseEnter( "replaymg" ) private.ButtonMouseEnterAdd( "replaymg" ) end,
      event_mleave = function () private.ButtonMouseLeave( "replaymg" ) private.ButtonMouseLeaveAdd( "replaymg" ) end
    } 
  );

  ObjSet( "btn_extra_replayho_play", 
    {
      event_mdown =  function () private.ReplayHoPlay() end, 
      event_menter = function () private.ButtonMouseEnter( "replayho_frame" ) end,
      event_mleave = function () private.ButtonMouseLeave( "replayho_frame" ) end
    } 
  );

  ObjSet( "btn_extra_replayho_button", 
    {
      event_mdown =  function () private.ReplayHoPlay() end, 
      event_menter = function () private.ButtonMouseEnter( "replayho_button" ) end,
      event_mleave = function () private.ButtonMouseLeave( "replayho_button" ) end
    } 
  );

  ObjSet( "btn_extra_replaymg_play", 
    {
      event_mdown =  function () private.ReplayMgPlay() end, 
      event_menter = function () private.ButtonMouseEnter( "replaymg_frame" ) end,
      event_mleave = function () private.ButtonMouseLeave( "replaymg_frame" ) end
    } 
  );

  ObjSet( "btn_extra_replaymg_button", 
    {
      event_mdown =  function () private.ReplayMgPlay() end, 
      event_menter = function () private.ButtonMouseEnter( "replaymg_button" ) end,
      event_mleave = function () private.ButtonMouseLeave( "replaymg_button" ) end
    } 
  );

  ObjSet( "btn_extra_screensaver", 
    {
      event_mdown =  function () private.ShowScreen( "screensaver" ); end,
      event_menter = function () private.ButtonMouseEnter( "screensaver" ) private.ButtonMouseEnterAdd( "screensaver" ) end,
      event_mleave = function () private.ButtonMouseLeave( "screensaver" ) private.ButtonMouseLeaveAdd( "screensaver" ) end
    } 
  );

  -- сохранить музыку
  common.dialog.common.buttons.savemusic = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  -- сохранить арт
  common.dialog.common.buttons.saveart = { left = { text = "ok", func = "save" }, center = nil, right = { text = "no", func = "Close" } };
  -- установить обои
  common.dialog.common.buttons.setwallpaper = { left = { text = "ok", func = "set" }, center = nil, right = { text = "no", func = "Close" } };
  -- установить заставку
  common.dialog.common.buttons.setscreen = { left = { text = "ok", func = "setscreen" }, center = nil, right = { text = "no", func = "Close" } };
  -- не полная версия
  common.dialog.common.buttons[ "notfull" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };
  local set_table = {};

  for i = 1,4 do

    table.insert( set_table, { "btn_extra_music_"..i, 
      {
        event_mdown = function() private.BtnMusicPlay( i ); end ,
        event_menter = function () private.ButtonMouseEnter( "music_"..i ); end,
        event_mleave = function () private.ButtonMouseLeave( "music_"..i ); end
      } 
    } );

  end;

  ObjMultiSet( set_table );

  private.current_screen = "wallpapers";
  private.wallpapers = {};
  private.wallpapers.current_number = 1;
  private.wallpapers.MAX_COUNT = 10;
  private.conceptart = {};
  private.conceptart.current_number = 1;
  private.conceptart.MAX_COUNT = 10;
  private.music = {};
  private.music.current_number = 1;
  private.music.MAX_COUNT = 4;
  private.music.vid_number = 1;
  private.music.is_playing = "";

  -----------------------------------------------------------------------

  private.replayho = {};
    private.replayho.loc = {

     "ho_darkcorner"
    ,"ho_minibar"
    ,"ho_portraithall"
    ,"ho_signs"  
  
    ,"ho_baths"
    ,"ho_underbookcase" 
    ,"ho_winecollection"
    ,"ho_withflashlight"  
  
    ,"ho_in_safe"
    ,"ho_knight_arrmor"
    ,"ho_lucien_table"
    ,"ho_weapon"
  
    ,"ho_in_chest"
    ,"ho_next_armchair"
    ,"ho_stone_stash"
    ,"ho_storage"
  };
  private.replayho.current_number = 1;
  private.replayho.MAX_COUNT = #private.replayho.loc;

  -----------------------------------------------------------------------

  private.replaymg = {};
  private.replaymg.loc = {

     "mg_inthreewaymirror"
    ,"mg_onworkbench"
    ,"mg_scaryhead"
  
    ,"mg_chain"
    ,"mg_incabinet"
    ,"mg_librarysecret"
  
    ,"mg_boss_fight"
    ,"mg_catacomb"
    ,"mg_clock"    
  
    ,"mg_attack"
    ,"mg_catacombs_fear"
    ,"mg_gates_lvl4"
    ,"mg_minigame_3" 
  };
  private.replaymg.current_number = 1;
  private.replaymg.MAX_COUNT = #private.replaymg.loc;

  -----------------------------------------------------------------------

  private.StartAnims();
  ObjSet( "txt_extra_play", { text = "1/"..private.wallpapers.MAX_COUNT } );
  
end;
--******************************************************************************************
function public.PreOpen()
 
  local lock_replay_visible = not ng_global.progress[ "ext" ].common.gamewin;

  ObjMultiSet( { 
    { "spr_extra_replayho_frame_lock", { visible = lock_replay_visible } },        
    { "spr_extra_replaymg_frame_lock", { visible = lock_replay_visible } },        
  } );
  
  common_impl.PlayAudio(  "mus", "rm_extra_track/track_"..math.random( 4 ), 1 );

  for track_number = 1,4 do
    ObjSet( "spr_extra_music_"..track_number.."_play" , { alp = 0 } );
    ObjSet( "spr_extra_music_"..track_number,           { alp = 1 } );
  end;

  if GetPlatform() == "mac" then
    ObjSet( "btn_extra_screensaver", { active = false, visible = false, input = false } );
  end;  

end;
--******************************************************************************************
function public.Open()

  --private.music.is_playing

  common_impl.EnvPlay( { "rm_extra_track/aud_extra_env" }, "", 0.5 );

end;
--******************************************************************************************
function public.Close()

  if private.music.is_playing ~= "" then

    common_impl.StopAudio( "mus",  "menu/rm_extra/layers/music/track_"..private.music.is_playing, 0.2 )
    ObjSet( "spr_extra_stop_"..private.music.is_playing , { alp = 0 } );
    ObjSet( "spr_extra_play_"..private.music.is_playing , { alp = 1 } );
    private.music.is_playing = "";

  end;

end;
--******************************************************************************************
function private.ShowScreen ( new_screen )
  
  if ( private.current_screen == new_screen ) then
    return;
  end;

  local func_end = function ()

    private.current_screen = new_screen;
    common_impl.Lock( false );

  end;

  local func_after = function ()

    local params = {};
    -----------------------------------
    local music_alp,    music_active = 0, false;
    local picture_alp,  picture_active = 0, false;
    local replayho_alp, replayho_active = 0, false;
    local replaymg_alp, replaymg_active = 0, false;

    if ( new_screen == "conceptart" or new_screen == "wallpapers" or new_screen == "bonus_chapter" or new_screen == "screensaver" ) then

      picture_alp, picture_active = 1, true;

    elseif ( new_screen == "music" ) then

      music_alp, music_active = 1, true;

    elseif ( new_screen == "replayho" ) then

      replayho_alp, replayho_active = 1, true;

    elseif ( new_screen == "replaymg" ) then

      replaymg_alp, replaymg_active = 1, true;

    end;  
    -----------------------------------
    local text = "";
    local res = "";
    local res_replay = "";
    local back_alp = 1;
    local arrow_alp = 1;

    local button_left_input = true;
    local button_right_input = true;

    local button_play_visible = true;
    local button_set_visible = false;
    local button_save_visible = false;

    local button_play_input = false;
    local button_set_input = true;
    local button_save_input = false;

    if ( new_screen == "bonus_chapter" ) then
      text = "str_extra_play";
      res = "assets/levels/menu/rm_extra/layers/extra_gameplay";
      back_alp = 1;
      arrow_alp = 0;

      button_left_input = false;
      button_right_input = false;

      button_play_visible = true;
      button_set_visible = false;
      button_save_visible = false;

      button_play_input = true;
      button_set_input = false;
      button_save_input = false;

    elseif new_screen == "screensaver" then

      res = "assets/levels/menu/rm_extra/layers/screensaver";
      color = { r = 0.9921, g = 0.5859, b = 0.2578 };
      back_alp = 0;
      arrow_alp = 0;

      button_left_input  = false;
      button_right_input = false;

      button_play_visible = false;
      button_set_visible  = true;
      button_save_visible = false;

      button_play_input = false;
      button_set_input  = true;
      button_save_input = false;

    elseif ( new_screen == "replayho" or new_screen == "replaymg" ) then

      text = private[ new_screen ].current_number.."/"..private[ new_screen ].MAX_COUNT;
      res_replay = "assets/levels/menu/rm_extra/layers/replay/minibacks/"..private[ new_screen ].loc[ private[ new_screen ].current_number ];

      lock_replay_visible = not ng_global.progress[ "ext" ].common.gamewin;

    else

      text = private[ new_screen ].current_number.."/"..private[ new_screen ].MAX_COUNT;
      res = "assets/levels/menu/rm_extra/layers/"..new_screen.."/mini/"..private[new_screen].current_number;

    end;

    if ( new_screen == "wallpapers" ) then
      button_play_visible = true;
      button_set_visible = true;
      button_save_visible = false;

      button_play_input = false;
      button_set_input = true;
      button_save_input = false;
    end;

    if ( new_screen == "music" ) then
      button_play_visible = false;
      button_set_visible = false;
      

      button_play_input = false;
      button_set_input = false;
      
      if GetPlatform() == "ios" then
        button_save_visible = false;
        button_save_input = false;
      else
        button_save_visible = true;
        button_save_input = true;
      end;
      
    end;

    if ( new_screen == "conceptart" ) then
      button_play_visible = true;
      button_set_visible = false;
      button_save_visible = true;

      button_play_input = false;
      button_set_input = false;
      button_save_input = true;
    end;

    if ( new_screen == "replayho" or new_screen == "replaymg" ) then
      button_play_visible = true;
      button_set_visible  = false;
      button_save_visible = false;

      button_play_input = true;
      button_set_input  = false;
      button_save_input = false;

      button_left_input  = true;
      button_right_input = true;

    end;

    -----------------------------------
    
    ObjSet( "spr_extra_picture", { res = res } );
    ObjSet( "txt_extra_play", { text = text } );
    ObjSet( "spr_extra_play_back", { alp = back_alp } );

    ObjSet( "btn_extra_change_lft", { alp = arrow_alp, input = button_left_input } );
    ObjSet( "btn_extra_change_rgt", { alp = arrow_alp, input = button_right_input } );

    ObjSet( "obj_extra_music_list",    { input = music_active,    visible = music_active } )    
    ObjSet( "txt_extra_title", { text = "str_extra_"..new_screen } )

    ObjSet( "btn_extra_play", { input = button_play_input, visible = button_play_visible } );
    ObjSet( "btn_extra_set", { input = button_set_input, visible = button_set_visible } );
    ObjSet( "btn_extra_save", { input = button_save_input, visible = button_save_visible } );

    ObjSet( "obj_extra_replayho_list", { input = replayho_active, visible = replayho_active } )    
    ObjSet( "obj_extra_replaymg_list", { input = replaymg_active, visible = replaymg_active } )    

    ObjSet( "spr_extra_replayho_frame_lock", { visible = lock_replay_visible } )        
    ObjSet( "spr_extra_replaymg_frame_lock", { visible = lock_replay_visible } )

    ObjSet( "btn_extra_replayho_button", { input = replayho_active, visible = replayho_active } )    
    ObjSet( "btn_extra_replaymg_button", { input = replaymg_active, visible = replaymg_active } )    
    

    if ( res_replay ~= "" ) then

      ObjSet( "spr_extra_"..new_screen.."_miniback", { res = res_replay } );

    end;

    ObjAnimate( "spr_extra_picture", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 0, 
      0.4, 0, picture_alp 
    } );

    ObjAnimate( "obj_extra_music_list", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.4, 0, music_alp 
    } );

    ObjAnimate( "obj_extra_replayho_list", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.4, 0, replayho_alp 
    } );

    ObjAnimate( "obj_extra_replaymg_list", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.4, 0, replaymg_alp 
    } );

  end;  

  common_impl.Lock( true );

  ObjAnimate( "spr_extra_picture", "alp", 0, 0, func_after, 
  { 
    0.0, 0, ObjGet( "spr_extra_picture" ).alp, 
    0.2, 0, 0 
  } );

  ObjAnimate( "obj_extra_music_list", "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "obj_extra_music_list" ).alp, 
    0.2, 0, 0 
  } );

  ObjAnimate( "obj_extra_replayho_list", "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "obj_extra_replayho_list" ).alp, 
    0.4, 0, 0 
  } );

  ObjAnimate( "obj_extra_replaymg_list", "alp", 0, 0, "", 
  { 
    0.0, 0, ObjGet( "obj_extra_replaymg_list" ).alp, 
    0.4, 0, 0 
  } );

end;
--******************************************************************************************
function private.ArrowClick ( direction )

  local new_res = 1;

  if not direction then

    if private[private.current_screen].current_number < private[private.current_screen].MAX_COUNT then

      new_res = private[private.current_screen].current_number + 1;

    end;

  else 

    if private[private.current_screen].current_number == 1 then

      new_res = private[private.current_screen].MAX_COUNT;

    else

      new_res = private[private.current_screen].current_number - 1;      

    end;

  end;

  if private.current_screen == "music" then

    private.BtnMusicPlay( new_res );

  elseif private.current_screen == "replayho" or private.current_screen == "replaymg" then

    common_impl.Lock( true );

    local obj_name = "spr_extra_"..private.current_screen.."_miniback";

    local anm_after = function ()

      local func_after = function ()

        common_impl.Lock( false );
        private[ private.current_screen ].current_number = new_res;

      end;

      ObjSet( obj_name,
      {
        res = "assets/levels/menu/rm_extra/layers/replay/minibacks/"..private[ private.current_screen ].loc[ new_res ];
      } );

      ObjSet( "txt_extra_play", { text = new_res.."/"..private[private.current_screen].MAX_COUNT } );

      ObjAnimate( obj_name, "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 });

    end;

    ObjAnimate( obj_name, "alp", 0, 0, anm_after, { 0,0,1, 0.2,0,0 });

  else

    common_impl.Lock( true );

    local anm_after = function ()

      local func_after = function ()

        common_impl.Lock( false );
        private[private.current_screen].current_number = new_res;

      end;

      ObjSet( "spr_extra_picture",
      {
        res = "assets/levels/menu/rm_extra/layers/"..private.current_screen.."/mini/"..new_res
      } );
      ObjSet( "txt_extra_play", { text = new_res.."/"..private[private.current_screen].MAX_COUNT } );

      ObjAnimate( "spr_extra_picture", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 });

    end;

    ObjAnimate( "spr_extra_picture", "alp", 0, 0, anm_after, { 0,0,1, 0.2,0,0});

  end;

end;
--******************************************************************************************
function private.BtnMusicPlay ( track_number )

  if private.music.is_playing == "" then

    local vid_after = function ()

      private.music.vid_number = new_vid;
      common_impl.Lock( false );

      ObjSet( "spr_extra_music_"..track_number.."_play" , { alp = 1 } );
      ObjSet( "spr_extra_music_"..track_number, { alp = 0 } );
      private.music.current_number = track_number;
      private.music.is_playing = track_number;

      common_impl.PlayAudio( "mus", "rm_extra_track/track_"..private.music.is_playing, 0.2 );

    end;

    common_impl.Lock( true );
    vid_after();

  else

    common_impl.StopAudio( "mus",  "rm_extra_track/track_"..private.music.is_playing, 0.2 )

    local vid_after;

    if private.music.is_playing == track_number then

       vid_after = function ()

        common_impl.Lock( false );
        ObjSet( "spr_extra_music_"..private.music.is_playing.."_play" , { alp = 0 } );
        ObjSet( "spr_extra_music_"..private.music.is_playing, { alp = 1 } );
        private.music.current_number = track_number;
        private.music.is_playing = "";

      end;

    else

      vid_after = function ()

        common_impl.Lock( false );
        ObjSet( "spr_extra_music_"..private.music.is_playing.."_play" , { alp = 0 } );
        ObjSet( "spr_extra_music_"..private.music.is_playing, { alp = 1 } );
        private.music.is_playing = "";
        private.BtnMusicPlay( track_number )

      end;

    end;

    common_impl.Lock( true );
    vid_after();


  end;

end;
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )

  SetCursor( CURSOR_HAND );

  local obj = "spr_extra_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );
 
  --cmn.PlayAudio( "sfx", "common/audio/aud_menter_sfx" );

end;
--******************************************************************************************
function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_extra_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  
end;

--******************************************************************************************
function private.ButtonMouseEnterAdd ( but_name )
  
  local obj2 = "spr_extra_"..but_name.."_focus2";
  local alp2 = ObjGet( obj2 ).alp;
  ObjAnimate( obj2, "alp", 0, 0, "", { 0, 0, alp2, ( common_impl.animtime * ( 1 - alp2 ) ), 0, 1 } );
  
end;
function private.ButtonMouseLeaveAdd ( but_name )
  local obj2 = "spr_extra_"..but_name.."_focus2";
  local alp2 = ObjGet( obj2 ).alp;
  ObjAnimate( obj2, "alp", 0, 0, "", { 0, 0, alp2, ( common_impl.animtime * alp2 ), 0, 0 } );
end;
--******************************************************************************************
function private.ButtonSetClick ()

  common_impl.PlayAudio( "sfx", "aud_click_menu" );

  if ( private.current_screen == "bonus_chapter" ) then

    if not IsDemoEdition() then

      if ng_global.progress[ "std" ].common.gamewin then

        if ng_global.progress[ "ext" ].common.gamewin == true and
          ng_global.progress[ "ext" ].common.gamestart == false then 
          
          common.DialogWindowShow( "common", "finishext", true );
          
        else
        
          ng_global.currentprogress = "ext";

          if ( not ng_global.progress[ "ext" ].common.gamestart ) then
            ng_global.progress[ "ext" ].common.gamestart = true;
          end;

          SetCursor( CURSOR_DEFAULT );
          local level = ng_global.progress[ "ext" ].common.chapter;
          cmn.is_inmenunow = false;
          common.LevelSwitch( level );

        end;
          
      else

        common.DialogWindowShow( "common", "unlockextra" );

      end;

    else

        common.DialogWindowShow( "common", "notfull" );

    end;

  else

    if IsDemoEdition() then

      common.DialogWindowShow( "common", "notfull" );

    else

      if ( private.current_screen == "music" ) then
        common.DialogWindowShow( "common", "savemusic" );
      elseif ( private.current_screen == "wallpapers" ) then
        common.DialogWindowShow( "common", "setwallpaper" );
      elseif ( private.current_screen == "conceptart" ) then
        common.DialogWindowShow( "common", "saveart" );
      elseif ( private.current_screen == "screensaver" ) then
        common.DialogWindowShow( "common", "setscreen", true );
      end;

    end;
  
  end;

end;
--******************************************************************************************
function private.ReplayMgPlay () 

  if not IsDemoEdition() then

    if ng_global.progress[ "ext" ].common.gamewin then

      local prg = "scr";
      ng_global.currentprogress = prg;

      if ( not ng_global.progress[ prg ].common.gamestart ) then
        ng_global.progress[ prg ].common.gamestart = true;
      end;

      SetCursor( CURSOR_DEFAULT );

      local loc_number = private.replaymg.current_number;

      ng_global.progress[ prg ].common.currentroom = private.replaymg.loc[ loc_number ].."_scr";
      ng_global.progress[ prg ].common.chapter = "levelscr";
      local level = ng_global.progress[ prg ].common.chapter;

      cmn.is_inmenunow = false;
      common.LevelSwitch( level );

    else

      common.DialogWindowShow( "common", "unlock_mg_and_ho" );

    end;

  else

    common.DialogWindowShow( "common", "notfull" );

  end;
 
end;
--******************************************************************************************
function private.ReplayHoPlay () 

  if not IsDemoEdition() then

    if ng_global.progress[ "ext" ].common.gamewin then

      local prg = "scr";
      ng_global.currentprogress = prg;
      
      if ( not ng_global.progress[ prg ].common.gamestart ) then
        ng_global.progress[ prg ].common.gamestart = true;
      end;

      SetCursor( CURSOR_DEFAULT );

      local loc_number = private.replayho.current_number;

      ng_global.progress[ prg ].common.currentroom = private.replayho.loc[ loc_number ].."_scr";
      ng_global.progress[ prg ].common.chapter = "levelscr";
      local level = ng_global.progress[ prg ].common.chapter;

      cmn.is_inmenunow = false;
      common.LevelSwitch( level );

    else

      common.DialogWindowShow( "common", "unlock_mg_and_ho" );

    end;

  else

    common.DialogWindowShow( "common", "notfull" );

  end;
 
end;
--******************************************************************************************
function private.SecretRoomPlay () 

  if not IsDemoEdition() then

    if ( ng_global.progress[ "ext" ].common.gamewin ) then

      local prg = "secret";
      ng_global.currentprogress = prg;

      if ( not ng_global.progress[ prg ].common.gamestart ) then

        if ( ng_global.progress[ prg ].common.gamewin ) then

          common.ResetSecretroom();
          ng_global.progress[ prg ].common.gamewin = false;

        end;

        ng_global.progress[ prg ].common.gamestart = true;

        SetCursor( CURSOR_DEFAULT );
        local level = ng_global.progress[ prg ].common.chapter;
        cmn.is_inmenunow = false;
        common.LevelSwitch( level );


      else 

        common.DialogWindowShow( "common", "continuesecret" );

      end;

    else

      common.DialogWindowShow( "common", "unlocksecret" );

    end;

  else

    common.DialogWindowShow( "common", "notfull" );

  end;
 
end;
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
--******************************************************************************************
--function --**ANIMATIONS**-- () end;
--******************************************************************************************
function private.StartAnims ()

  --ObjAnimate( "spr_extra_light", "alp", 1, 0, "",
  --{
  --  0.0,  0, 1.0,
  --  2.5,  0, 0.6,
  --  4.8,  0, 0.93,
  --  7.0,  3, 0.5,
  --  9.0,  2, 1.0
  --} );

end;
--******************************************************************************************
--function --**COMMON DIALOG**-- () end;
--******************************************************************************************
function common.dialog.common.save()

  if private.current_screen == "music" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/music/soundtrack_"..private[private.current_screen].current_number..".mp3" );
    
  elseif private.current_screen == "conceptart" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/conceptart/"..private[private.current_screen].current_number.."_conceptart" );

  elseif private.current_screen == "wallpapers" then

    CopyFileToMyDocs( "assets/levels/menu/rm_extra/layers/wallpapers/"..private[private.current_screen].current_number );

  end;

  common.DialogWindowHide( "common" );

end;
--------------------------------------------------------------------
function common.dialog.common.set()

  local way = "assets/levels/menu/rm_extra/layers/wallpapers/"..private[private.current_screen].current_number;

  CopyFileToMyDocs( way );

  common.DialogWindowHide( "common" );

end;
--------------------------------------------------------------------
function common.dialog.common.setscreen()

  local way = "assets/levels/menu/rm_extra/screensaver/haunted_hotel_silent_waters.scr";

  SetScreensaver( way );

  common.DialogWindowHide( "common" );

end;