-- name=ho_lucien_table_scr
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------------
  room.Define( "lucien_table_scr" );
  game.relations[ "ho_lucien_table_scr" ].exitroom = "rm_lucien_room";
  private.room_objname = "ho_lucien_table_scr";
  --------------------------------------------------------------------------------------------------
  ObjMultiSet( {
    { "spr_lucien_table_scr_apple",        { event_mdown = function() private.TaskComplete( 'apple'      ) end } },
    { "spr_lucien_table_scr_cup",          { event_mdown = function() private.TaskComplete( 'cup'        ) end } },
    { "spr_lucien_table_scr_flower",       { event_mdown = function() private.TaskComplete( 'flower'     ) end } },
    { "spr_lucien_table_scr_glasses",      { event_mdown = function() private.TaskComplete( 'glasses'    ) end } },
    { "spr_lucien_table_scr_repairs",      { event_mdown = function() private.TaskComplete( 'repairs'    ) end } },
    { "spr_lucien_table_scr_sea_horse",    { event_mdown = function() private.TaskComplete( 'sea_horse'  ) end } },
    { "spr_lucien_table_scr_triangle",     { event_mdown = function() private.TaskComplete( 'triangle'   ) end } },
    { "spr_lucien_table_scr_watch",        { event_mdown = function() private.TaskComplete( 'watch'      ) end } },
    { "spr_lucien_table_scr_watch_part",   { event_mdown = function() private.TaskComplete( 'watch_part' ) end } },
    { "spr_lucien_table_scr_heart",        { event_mdown = function() private.TaskComplete( 'heart'      ) end } },

    { "spr_lucien_table_scr_button_1",     { event_mdown = function() private.TaskComplete( 'button',  1 ) end } },
    { "spr_lucien_table_scr_button_2",     { event_mdown = function() private.TaskComplete( 'button',  2 ) end } },
    { "spr_lucien_table_scr_button_3",     { event_mdown = function() private.TaskComplete( 'button',  3 ) end } },

    { "spr_lucien_table_scr_pen_1",        { event_mdown = function() private.TaskComplete( 'pen',     1 ) end } },
    { "spr_lucien_table_scr_pen_2",        { event_mdown = function() private.TaskComplete( 'pen',     2 ) end } },
    { "spr_lucien_table_scr_pen_3",        { event_mdown = function() private.TaskComplete( 'pen',     3 ) end } },

    { "spr_lucien_table_scr_flower_part1", { event_dragdrop = function() private.DropFlowerPart1()         end } },
    { "spr_lucien_table_scr_flower_part2", { event_dragdrop = function() private.DropFlowerPart2()         end } },
    { "spr_lucien_table_scr_knife",        { event_dragdrop = function() private.DropKnife()               end } },

    { "obj_lucien_table_scr_clk_button",   { event_mdown = function()  private.AnimButton() end                } },
  } );
  --------------------------------------------------------------------------------------------
  -- function win_lucien_table_scr () end;
  --------------------------------------------------------------------------------------------    
  common_impl.hint[ "win_lucien_table_scr" ] = {
    type = "win",
    room = "rm_lucien_room",
    zz = "ho_lucien_table_scr",
    zz_gate = "gho_lucien_room_lucien_table_scr"
  };
  local win_lucien_table_scr_inv = function ()
  
    if ( cmn.IsEventDone( "win_lucien_table_scr" ) ) then

    end;
    
  end;
  local win_lucien_table_scr_loc = function ()
  
    if ( cmn.IsEventDone( "win_lucien_table_scr" ) ) then

    end;
    
  end;

  cmn.AddSubscriber( "win_lucien_table_scr", win_lucien_table_scr_inv );
  cmn.AddSubscriber( "win_lucien_table_scr", win_lucien_table_scr_loc, "rm_lucien_room" );
  --------------------------------------------------------------------------------------------------
  local start_lucien_table_scr_func = function ()

  if ( cmn.IsEventStart( "win_lucien_table_scr" ) ) then

  end;

  end;
  cmn.AddSubscriber( "win_lucien_table_scr", start_lucien_table_scr_func, private.room_objname );  
  --------------------------------------------------------------------------------------------------
  local unmark_heart_func = function ()    

    ObjDelete( "obj_lucien_table_scr_use_knife" );
    ObjMultiSet( {
      { "spr_lucien_table_scr_heart",     { alp = 1, input = true  } },
      { "spr_lucien_table_scr_bag_open",  { alp = 1                } },
      { "spr_lucien_table_scr_patch_bag", { alp = 1                } },
      { "spr_lucien_table_scr_knife",     { alp = 0, input = false } },
      { "spr_lucien_table_scr_bag",       { alp = 0                } },
      { "anm_lucien_table_scr_knife",     { alp = 0                } },
    });

  end;
  cmn.AddSubscriber( "unmark_heart_func", unmark_heart_func, private.room_objname );  
   --------------------------------------------------------------------------------------------------
  local unmark_flower1_func = function ()    
   
    ObjDelete( "obj_lucien_table_scr_use_flower1" );
    ObjMultiSet( {
      { "spr_lucien_table_scr_flower_part1",   { alp = 0, input = false } },
      { "spr_lucien_table_scr_glasses_close1", { alp = 1                } },
    });

    if ( cmn.IsUnmarkedTask( "lucien_table_scr", "flower2" ) ) then
      ObjMultiSet( {
        { "spr_lucien_table_scr_flower_part1",  { alp = 0  } },
        { "spr_lucien_table_scr_flower_part2",  { alp = 0  } },
        { "spr_lucien_table_scr_flower_broken", { alp = 0  } },
        { "spr_lucien_table_scr_flower",        { alp = 1, input = true  } },
      }); 
    end; 

  end;
  cmn.AddSubscriber( "unmark_flower1_func", unmark_flower1_func, private.room_objname );   
   --------------------------------------------------------------------------------------------------
  local unmark_flower2_func = function ()    
   
    ObjDelete( "obj_lucien_table_scr_use_flower2" );
    ObjMultiSet( {
      { "spr_lucien_table_scr_flower_part2",   { alp = 0, input = false } },
      { "spr_lucien_table_scr_glasses_close2", { alp = 1                } },
    });

    if ( cmn.IsUnmarkedTask( "lucien_table_scr", "flower1" ) ) then
      ObjMultiSet( {
        { "spr_lucien_table_scr_flower_part1",  { alp = 0  } },
        { "spr_lucien_table_scr_flower_part2",  { alp = 0  } },
        { "spr_lucien_table_scr_flower_broken", { alp = 0  } },
        { "spr_lucien_table_scr_flower",        { alp = 1, input = true  } },
      });
    end; 

  end;
  cmn.AddSubscriber( "unmark_flower2_func", unmark_flower2_func, private.room_objname );   

end;
--*********************************************************************************************************************
function public.PreOpen ()

  cmn.StopMusEnv();
  common_impl.StopAllMus();

  common_impl.PlayMusEnvHO();
  cmn.PlayMusEnv( "mus_env/aud_ho_mus_env", true );
  common_impl.PlayAudio( "env", "level3/env/aud_lucien_room_env", 0, "", 0 );

  if ( not cmn.IsEventDone( "opn_lucien_table_scr" ) ) then
  
    cmn.SetEventDone( "opn_lucien_table_scr" );

  end;
  
   cmn.InitHo( "lucien_table_scr" );
   cmn.SetMarkedTask( "lucien_table_scr", "heart"   );
   cmn.SetMarkedTask( "lucien_table_scr", "flower1" );
   cmn.SetMarkedTask( "lucien_table_scr", "flower2" );
   cmn.SetMarkedTask( "lucien_table_scr", "flower"  );
  
  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "apple",      1, 0, { { "spr_lucien_table_scr_apple"      } } );
  interface.TaskPanelTaskAdd( ho_items, "cup",        1, 0, { { "spr_lucien_table_scr_cup"        } } );
  interface.TaskPanelTaskAdd( ho_items, "glasses",    1, 0, { { "spr_lucien_table_scr_glasses"    } } );
  interface.TaskPanelTaskAdd( ho_items, "repairs",    1, 0, { { "spr_lucien_table_scr_repairs"    } } );
  interface.TaskPanelTaskAdd( ho_items, "sea_horse",  1, 0, { { "spr_lucien_table_scr_sea_horse"  } } );
  interface.TaskPanelTaskAdd( ho_items, "triangle",   1, 0, { { "spr_lucien_table_scr_triangle"   } } );
  interface.TaskPanelTaskAdd( ho_items, "watch",      1, 0, { { "spr_lucien_table_scr_watch"      } } );
  interface.TaskPanelTaskAdd( ho_items, "watch_part", 1, 0, { { "spr_lucien_table_scr_watch_part" } } );

  interface.TaskPanelTaskAdd( ho_items, "flower",     1, 1, { { "spr_lucien_table_scr_flower_part1", "obj_lucien_table_scr_use_flower1" },
                                                              { "spr_lucien_table_scr_flower_part2", "obj_lucien_table_scr_use_flower2" },
                                                              { "spr_lucien_table_scr_flower" } 
                                                            } );
  interface.TaskPanelTaskAdd( ho_items, "heart",      1, 1, { { "spr_lucien_table_scr_knife", "obj_lucien_table_scr_use_knife" }, 
                                                              { "spr_lucien_table_scr_heart" } 
                                                            } );

  interface.TaskPanelTaskAdd( ho_items, "button",     3, 0, { { "spr_lucien_table_scr_button_1" }, 
                                                              { "spr_lucien_table_scr_button_2" }, 
                                                              { "spr_lucien_table_scr_button_3" } 
                                                            } );
  interface.TaskPanelTaskAdd( ho_items, "pen",        3, 0, { { "spr_lucien_table_scr_pen_1"    }, 
                                                              { "spr_lucien_table_scr_pen_2"    }, 
                                                              { "spr_lucien_table_scr_pen_3"    } 
                                                            } );

  interface.TaskPanelTaskAdd( ho_items, "flower2",    0, 0, { { "spr_lucien_table_scr_flower_part1", "obj_lucien_table_scr_use_flower1" } } ); 
  interface.TaskPanelTaskAdd( ho_items, "flower1",    0, 0, { { "spr_lucien_table_scr_flower_part2", "obj_lucien_table_scr_use_flower2" } } );               

  interface.TaskPanelShow( ho_items );  

end;
--*********************************************************************************************************************
function public.Open () 
  --common_impl.PassingHoStart();
end;
--*********************************************************************************************************************
function public.PreClose ()
  interface.TaskPanelHide();
end;
--*********************************************************************************************************************
function public.Close ()
  cmn.PlayMusEnv();
  --common_impl.PassingHoStop();
end;
--*********************************************************************************************************************
function public.HoComplete ()
  --common_impl.PassingHoWin(); 
end;
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part )
  
  local object = "spr_lucien_table_scr_"..task_name;
  if ( part ) then
    object = object.."_"..part;
  end;
  cmn.HoTaskFind( object, task_name );

  if ( task_name == "watch" ) then private.AnimScary(); end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.DropKnife ()
  
  if ( ObjIntersect( "spr_lucien_table_scr_knife", "obj_lucien_table_scr_use_knife" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "lucien_table_scr", "heart" );
      cmn.CallEventHandler( "unmark_heart_func" );

    end;
    
    cmn.Lock( true );

    ObjMultiSet( {
      { "spr_lucien_table_scr_knife", { alp = 0 } },
      { "spr_lucien_table_scr_bag",   { alp = 0 } },
      { "anm_lucien_table_scr_knife", { alp = 1 } },
    });
    AnimPlay( "anm_lucien_table_scr_knife", "knife", func_end );

    common_impl.PlayAudio( "sfx", "level3/sfx/aud_use_knife3", 0, "", 0 );
    
  else
    ObjSet( "spr_lucien_table_scr_knife", { pos_z = 1 } );
  end;
  
end;
--*********************************************************************************************************************
function private.DropFlowerPart1 ()
  
  if ( ObjIntersect( "spr_lucien_table_scr_flower_part1", "obj_lucien_table_scr_use_flower1" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "lucien_table_scr", "flower1" );

      if ( cmn.IsUnmarkedTask( "lucien_table_scr", "flower2" ) ) then cmn.UnmarkTask( "lucien_table_scr", "flower" ); end;

      cmn.CallEventHandler( "unmark_flower1_func" );

    end;
    
    cmn.Lock( true );
    func_end();
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_high", 0, "", 0 );
    
  else
    ObjSet( "spr_lucien_table_scr_flower_part1", { pos_z = 1 } );
  end;
  
end;
--*********************************************************************************************************************
function private.DropFlowerPart2 ()
  
  if ( ObjIntersect( "spr_lucien_table_scr_flower_part2", "obj_lucien_table_scr_use_flower2" ) ) then
  
    local func_end = function()
      
      cmn.Lock( false );
      cmn.UnmarkTask( "lucien_table_scr", "flower2" );

      if ( cmn.IsUnmarkedTask( "lucien_table_scr", "flower1" ) ) then cmn.UnmarkTask( "lucien_table_scr", "flower" );end;

      cmn.CallEventHandler( "unmark_flower2_func" );

    end;
    
    cmn.Lock( true );
    func_end();
    common_impl.PlayAudio( "sfx", "level2/sfx/aud_xx_clk_wood_high", 0, "", 0 );

  else
    ObjSet( "spr_lucien_table_scr_flower_part2", { pos_z = 1 } );
  end;
  
end;
--*********************************************************************************************************************
function private.AnimScary ()
  
  local func_end = function()
    cmn.Lock( false );
    ObjSet( "obj_lucien_table_scr_clk_button", { input = true } );
  end;
  
  cmn.Lock( true );
  AnimPlay( "anm_lucien_table_scr_scary", "scary", func_end );

end;
--*********************************************************************************************************************
function private.AnimButton ()
  
  local name = ""
  local random = math.random(1,2);
  
  if random == 1 then name = "button_click"
  else name = "button_click2"
  end;

  local animName = "anm_lucien_table_scr_"..name;
  
  local func_end = function()

    cmn.Lock( false );
    ObjMultiSet( {
      { "anm_lucien_table_scr_scary", { alp = 1 } },
      { animName,                 { alp = 0 } },
    });

  end;
  
  cmn.Lock( true );
  
  ObjMultiSet( {
    { "anm_lucien_table_scr_scary", { alp = 0 } },
    { animName,                 { alp = 1 } },
  });

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_xx_typewriter", 0, "", 0 );

  AnimPlay( animName, name, func_end );

end;
--********************************************************************************************************************