-- name=mg_boss_fight_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_boss_fight_scr";
  interface.DeployPreviousLoc ( { private.room_objname, "rm_brook" } );

  --------------------------------------------------------------------------------------------
  -- function win_boss_fight_scr () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_boss_fight_scr" ] = {
    type = "win",
    use_place = "gmg_brook_boss_fight_scr",
    room = "rm_brook",
    zz_gate = "gmg_brook_boss_fight_scr"
  };    
  
  local win_boss_fight_scr = function ()

    if ( cmn.IsEventDone( "win_boss_fight_scr" ) ) then  
     
    end;

  end;
  local win_boss_fight_scr_loc = function ()

    if ( cmn.IsEventDone( "win_boss_fight_scr" ) ) then  

    end;

  end;
  --cmn.AddSubscriber( "win_boss_fight_scr", win_boss_fight_scr, private.room_objname );
  --cmn.AddSubscriber( "win_boss_fight_scr", win_boss_fight_scr_loc, "rm_brook" );  
  --------------------------------------------------------------------------------------------
  
end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************


--*********************************************************************************************************************
function public.Open () 

  common_impl.ShowBbt( 'bbt_boss_fight_scr_opn_boss_fight' );
  
end;

--*********************************************************************************************************************
function public.PreOpen ()

  --common_impl.EnvPlay( { "level1/env/aud_porch_env" }, "", 0.5 );
  
  --int_slider.InitSlider( private.room_objname );
    
  --if not cmn.IsEventDone( "win_boss_fight_scr" ) then

    cmn.MiniGameShow();
   -- common_impl.PassingMgStart();
    
  --  private.is_need_achiev = true;

 -- end;

  --ObjAttach( "obj_int_taskpanel_boss_fight_scr", "int_taskpanel_impl" ); 
  
  
  
  private.Load();
  
  local ho_items = {};
  interface.TaskPanelShow( ho_items );
  
 -- if ( not cmn.IsEventDone( "win_boss_fight_scr" ) ) then
    
    common_impl.PlayAudio( "voc", "level3/voc/aud_fight_1_1_voc",  0, "", 0 );

  --end; 
  
end;


--*********************************************************************************************************************
function public.Close ()
end;

--*********************************************************************************************************************
function public.PreClose ()

  --common_impl.StopAudio( "env", "level1/env/aud_porch_env", 0.5 );
    
 -- if not cmn.IsEventDone( "win_boss_fight_scr" ) then

    cmn.MiniGameHide();
  --  common_impl.PassingMgStop();

 -- end;
  
  private.StopTimer(); 
  interface.TaskPanelHide();
  private.StopAllvoices(); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MINIGAME LOGIC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

private.gamedata = {};

private.time                = { 9999, 9999, 9999, 9999 };
private.areacount           = { 8, 12, 14, 3 };


private.voices_after_stroke = { "aud_fight_1_2_voc", 
                                "aud_fight_1_3_voc", 
                                "aud_fight_1_8_voc", 
                                "aud_fight_1_9_voc", 
                                "aud_fight_1_10_voc",
                                "aud_fight_1_11_voc",
                                "aud_fight_1_12_voc" 
                              };
                              
private.voices_during_stroke = { "aud_fight_1_4_voc", 
                                 "aud_fight_1_5_voc", 
                                 "aud_fight_1_6_voc",
                                 "aud_fight_1_7_voc" 
                               };

private.timer_count        = 0;
private.last_icon_position = 0;
private.last_voice_id      = 1;
--private.is_need_achiev     = false;

private.AREA_NAME       = "obj_boss_fight_scr_area_";
private.AREA_LIGHT_NAME = "spr_boss_fight_scr_area_";
private.ICON_NAME       = "spr_boss_fight_scr_button_amulet";
private.BUTTON_NAME     = "spr_boss_fight_scr_button_";
private.TIMER_NAME      = "tmr_boss_fight_scr_timer";

private.LEVEL_COUNT = 4;
private.VOICE_COUNT = 12;

--*******************************************************************************************************************
function private.Default ()

  ng_global.progress[ "scr" ][ "win_boss_fight_scr" ].cur_level   = 1;
  ng_global.progress[ "scr" ][ "win_boss_fight_scr" ].found_items = { {}, {}, {}, {} };
  
  AnimPlay( "anm_boss_fight_scr_our_hands", "arm", "" );  
  AnimPlay( "anm_boss_fight_scr_clark1", "clark1", "" );  
  ObjMultiSet( { 
    { "anm_boss_fight_scr_clark1",  { alp = 1 } },
    { "anm_boss_fight_scr_clark2",  { alp = 0 } },
    { "anm_boss_fight_scr_clark3",  { alp = 0 } },
  } );
  
end; 

--*******************************************************************************************************************
function private.Load ()

  --if ( not ng_global.progress[ "scr" ][ "win_boss_fight_scr" ].cur_level or
  --not ng_global.progress[ "scr" ][ "win_boss_fight_scr" ].found_items ) then 

    private.Default();

  --end; 
  
  private.gamedata = ng_global.progress[ "scr" ][ "win_boss_fight_scr" ];  
  
  --if ( private.gamedata.cur_level == 4 ) then
  --  
  --  private.gamedata.cur_level = 3;
  --  
  --end;
  
  local curLevel = private.gamedata.cur_level;
  private.pair = { 0, 0, 0 };
  private.sign = 1;
  private.UpdateAnimTag ();
  private.UseAnim ( curLevel );
  ng_global.progress[ "scr" ][ "win_boss_fight_scr" ].found_items[ curLevel ] = {};
  
end;


--*******************************************************************************************************************
function private.LogicInit () 
  
  
  local curLevel = private.gamedata.cur_level;
  
  for i = 1, private.LEVEL_COUNT, 1 do
    
    ObjMultiSet( { 
      { "obj_boss_fight_scr_stage_"..i,  { input = false } },
    } );
    
  end;
  
  ObjMultiSet( { 
    { "obj_boss_fight_scr_stage_"..curLevel,  { input = true } },
  } );    
  
    if curLevel == 1 then
      
      for j = 1, 4 do
        
        for k = 1, 2 do
          
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";
          
            ObjSet( curArea, {  
                                  alp = 0,
                                input = false,
                                event_mdown = function () private.AreaCheck( j, k ); end
                             } );  
            ObjSet( curSprArea, {
                                  alp = 1, 
                                  input = false,
                                } );  
            ObjDelete( curLightArea );   
            ObjDelete( curLightArea.."_ghost" );               

            if ( not private.IsItemFound( curLevel, curArea ) ) then
            
              ObjSet( curArea, {  
                                  input = true,
                                    alp = 1,
                               } );   
                                 
            end;
        
        end;
                          
      end;
                          
    elseif curLevel == 2 then   
     
      for j = 1, 4 do
        
        for k = 1, 3 do
        
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";
          
            ObjSet( curArea, {  
                                  alp = 0,
                                input = false,
                                event_mdown = function () private.AreaCheck( j, k ); end
                             } );  
            ObjSet( curSprArea, {
                                  alp = 1, 
                                  input = false,
                                } );  
            ObjDelete( curLightArea );   
            ObjDelete( curLightArea.."_ghost" );                

            if ( not private.IsItemFound( curLevel, curArea ) ) then
              
               ObjSet( curArea, {  
                                  input = true,
                                    alp = 1,
                               } );   
                                 
            end;
          
        end;
                          
      end;   
                            
    elseif curLevel == 3 then   
     
      for j = 1, 7 do
        
        for k = 1, 2 do
        
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";
          
            ObjSet( curArea, {  
                                  alp = 0,
                                input = false,
                                event_mdown = function () private.AreaCheck( j, k ); end
                             } );  
            ObjSet( curSprArea, {
                                  alp = 1, 
                                  input = false,
                                } );  
            ObjDelete( curLightArea );   
            ObjDelete( curLightArea.."_ghost" );                

            if ( not private.IsItemFound( curLevel, curArea ) ) then
              
              ObjSet( curArea, {  
                                  input = true,
                                    alp = 1,
                               } );   
                                 
            end;
          
        end;
                          
      end;      
                            
    elseif curLevel == 4 then   
     
      for j = 1, 12 do
        
        for k = 1, 3 do
        
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";
          
            ObjSet( curArea, {  
                                  alp = 0,
                                input = false,
                                event_mdown = function () private.AreaCheck( j, k ); end
                             } );  
            ObjSet( curSprArea, {
                                  alp = 1, 
                                  input = false,
                                } );  
            ObjDelete( curLightArea );   
            ObjDelete( curLightArea.."_ghost" );                

            if ( not private.IsItemFound( curLevel, curArea ) ) then
              
              ObjSet( curArea, {  
                                  input = true,
                                    alp = 1,
                               } );   
                                 
            end;
          
        end;
                          
      end;   
                            
    end;
  
end;

--*******************************************************************************************************************
function private.AreaCheck ( pairID, areaID ) 
    
  common_impl.PlayAudio( "sfx", "aud_clk_ho_sfx2", 0, "", 0 );
  
  if ( private.pair[ 1 ] == 0 ) then

    private.pair[ 1 ] = pairID;
    
  elseif ( private.pair[ 2 ] == 0 ) then
      
    private.pair[ 2 ] = pairID;  
    
  else
    
    private.pair[ 3 ] = pairID; 
    
  end;  
  
  private.SymbolCreating( pairID, areaID ); 
  
end;
--*******************************************************************************************************************
function private.SymbolCreating ( pairID, areaID )

  local curLevel = private.gamedata.cur_level;
  
  local curArea      = private.AREA_NAME..curLevel.."_"..pairID.."_"..areaID;
  local curAreaSpr   = private.AREA_LIGHT_NAME..curLevel.."_"..pairID.."_"..areaID;
  local curAreaLight = private.AREA_LIGHT_NAME..curLevel.."_"..pairID.."_"..areaID.."_light";
  local curRes = ObjGet( curAreaSpr );
  
  ObjCreate( curAreaLight, "spr" );    

  if private.PairsIsCheck() then 

    ObjSet( curAreaLight,
    {
      res = curRes.res.."_win",
      pos_z = 1;
    } );
    
  else 
    
    ObjSet( curAreaLight,
    {
      res = curRes.res.."_fail",
      pos_z = 1;
    } );
    
  end;

  ObjAttach( curAreaLight, curArea );  
  
  local func_end = function ()
    
    if not private.PairsIsCheck() then 
      
      private.StopTimer();
      private.gamedata.found_items[ curLevel ] = {};
      private.pair = { 0, 0, 0 }; 
      private.sign = 1;
      
      if curLevel == 4 then
        
        private.sign = 5; 
        
      end;
      
      private.WrongAnim( curLevel ); 

      cmn.Lock( true );
      
    else 
      
      if private.PairsCheck() then 
        
        private.PairsWin();
        
      end;
      
    end;
  
  end;  
  
  ObjAnimate( curAreaLight, "alp",0,0, func_end, { 0, 0, 0,    0.3, 0, 1  } );
  ObjAnimate( curAreaSpr, "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0  } );
  
end; 
--*******************************************************************************************************************
function private.PairsIsCheck()

  local curLevel = private.gamedata.cur_level;
  
  for i = 1,#private.pair do

    if ( private.pair[ i ] ~= private.pair[ 1 ] and
         private.pair[ i ] ~= 0 ) then
     
      return false;
      
    end;
    
  end;

  if ( curLevel % 2 == 0 ) and  
       private.pair[ 1 ] ~= private.sign then  

    return false;
      
  end;     
  
  return true;
  
end;
--*******************************************************************************************************************
function private.PairsCheck()
 
  local curLevel = private.gamedata.cur_level;
  local pair = 2;

  if ( curLevel % 2 == 0 ) then  
    
    pair = 3;
    
  end;
  
  for i = 1,pair do

    if ( private.pair[ i ] == 0 ) then
    
      return false;
      
    end;
    
  end;
  
  return true;
  
end;
--*******************************************************************************************************************
function private.PairsWin()
  
  local curLevel = private.gamedata.cur_level;
  local pair = 2;
  
  if ( curLevel % 2 == 0 ) then
    
    pair = 3;
    private.UpdateAnimTagSign();
    private.sign = private.sign + 1;
    
  end;  
  
  for i = 1,pair do

    private.AreaClick( private.pair[ 1 ], i ); 
    
  end;
    
end;
--*******************************************************************************************************************
function private.AreaClick ( pairID, areaID ) 
    
  common_impl.PlayAudio( "sfx", "aud_outro_3lvl", 0, "", 0 );
  
  local func_end = function ()
    
    cmn.Lock( false );
    private.pair = { 0, 0, 0 }; 
    private.Update( false );
    
  end;
   
  local curLevel = private.gamedata.cur_level;
  local curAreaSpr   = private.AREA_NAME..curLevel.."_"..pairID.."_"..areaID;
  
  table.insert( private.gamedata.found_items[ curLevel ], curAreaSpr );
  private.ParticlesCreating( pairID, areaID ); 
  
  if #private.gamedata.found_items[ curLevel ] == private.areacount[ curLevel ] then
    
    local curTime = private.timer_count;
    private.StopTimer();
    
    
    if curTime <= private.time[ curLevel ] then
      
      local func_end_right = function ()
        
        --ObjSet( "obj_int_taskpanel_boss_fight_scr", { alp = 0 } );
        
        if ( curLevel == 3 ) then
          
          private.UseAnim ( curLevel );
          
        else
          
          private.RightAnim( curLevel );    
        
        end;
        
      end; 

      private.gamedata.cur_level = private.gamedata.cur_level + 1;

      ObjAnimate( "obj_boss_fight_scr_icons", "alp",0,0, func_end_right, { 0, 0, 1,    1.1, 0, 1 } );
      
    else
      
      local func_end_wrong = function ()
        
        --ObjSet( "obj_int_taskpanel_boss_fight_scr", { alp = 0 } );
        private.WrongAnim( curLevel ); 
        
      end;
      
      private.gamedata.found_items[ curLevel ] = {};
      ObjAnimate( "obj_boss_fight_scr_icons", "alp",0,0, func_end_wrong, { 0, 0, 1,    1.1, 0, 1 } );
      
    end;
    
  end;
  
  cmn.Lock( true );
  common_impl.StopAudio( "sfx", "level3/sfx/aud_glow_crystall", 0.2 );
  common_impl.PlayAudio( "sfx", "level3/sfx/aud_glow_crystall", 0, "", 0 );
  ObjAnimate( curAreaSpr, "alp",0,0, "", { 0, 0, 1,    0.4, 0, 0 } );
  ObjAnimate( curAreaSpr, "scale_xy",0,0, func_end, { 0, 0, 1, 1,   0.2, 0, 1.6, 1.6, 0.3, 0, 0.6, 0.6, 0.5, 0, 1, 1,  } );  
  
end;


--*******************************************************************************************************************
function private.ParticlesCreating ( pairID, areaID )
 
  local curLevel = private.gamedata.cur_level;
  
  local curArea = "obj_boss_fight_scr_area_"..curLevel.."_"..pairID.."_"..areaID
  local curAreaX = ObjGet( curArea ).pos_x;
  local curAreaY = ObjGet( curArea ).pos_y;

  local curIcon = private.ICON_NAME;  
  local curIconX = ObjGet( curIcon ).pos_x;
  local curIconY = ObjGet( curIcon ).pos_y;
  
  local pfx = "pfx_boss_fight_scr_"..curLevel.."_"..pairID.."_"..areaID;
  local pfxPositionStart = GetObjPosByObj( curArea, "obj_boss_fight_scr_anim" );
  local pfxPositionEnd = GetObjPosByObj( curIcon, "obj_boss_fight_scr_anim" );
  
  local func_end = function ()
    
    ObjDelete( pfx );
    
  end;  
  
  ObjCreate( pfx, "partsys" );
  ObjSet( pfx,
  {
    res = "assets/levels/level3/mg_boss_fight/anims/pfx_effect",
    blendmode = 2, input = false, alp = 1, visible = true
  } );
  
  ObjAttach( pfx, "obj_boss_fight_scr_anim" );      
  ObjAnimate( pfx, "alp",0,0, func_end, { 0, 0, 1,    1.0, 0, 1,    1.1, 0, 0 } );
  
  ObjAnimate( pfx, "pos_xy",0,0, "", { 0, 3, pfxPositionStart[ 1 ], pfxPositionStart[ 2 ],
                                     1.0, 3, pfxPositionEnd[ 1 ], pfxPositionEnd[ 2 ] } );
      
end; 


--*******************************************************************************************************************
function private.RightAnim ( curLevel )
  
  local prevAnim_1 = "anm_boss_fight_scr_clark1";
  local prevAnimFunc_1 = "clark1";  
  
  if curLevel == 2 then
    
    prevAnim_1 = "anm_boss_fight_scr_clark2";    
    prevAnimFunc_1 = "clark2";  
    
  elseif curLevel == 3 or
         curLevel == 4 then
    
    prevAnim_1 = "anm_boss_fight_scr_clark3";       
    prevAnimFunc_1 = "clark3";  
        
  end;  
  
  local prevAnim_2 = "anm_boss_fight_scr_our_hands";
  local prevAnimFunc_2 = "arm";
  
  local nextAnim_1 = "";
  local nextAnimFunc_1 = "";
  
  local nextAnim_2 = "";
  local nextAnimFunc_2 = "";
  
  local func_end = function ()
    
    if ( curLevel % 2 ~= 0 ) then 
      
      private.PlayRandomVoice( "voices_after_stroke" );
      
    end;
    
    if curLevel == 1 then
      
      prevAnim_1 = "anm_boss_fight_scr_clark2";    
      prevAnimFunc_1 = "clark2";  
      
    elseif curLevel == 2 then
      
      prevAnim_1 = "anm_boss_fight_scr_clark3";       
      prevAnimFunc_1 = "clark3";  
          
    end;  
    
    ObjMultiSet( { 
      { prevAnim_1,  { alp = 1, frame = 0, playing = true } },
      { prevAnim_2,  { alp = 1 } },
      { nextAnim_1,  { alp = 0 } },
      { nextAnim_2,  { alp = 0 } },
      --{ "obj_int_taskpanel_boss_fight_scr",  { alp = 1 } },
    } );
  
    --cmn.Lock( false );
    --private.Update( true );
    --private.UpdateAnimTag(); 
    --private.UpdateAnimTagSign();
    if curLevel ~= 4 then
      
      cmn.Lock( false );      
      private.UseAnim ( curLevel );
      
    else
      
      cmn.Lock( false );
      private.Update( true );   
      
    end;
    
  end;
  
  if ( curLevel % 2 == 0 ) then
  
    --common_impl.PlayAudio( "sfx", "level3/sfx/aud_glow_crystall", 0, "", 0 );
    private.PlayRandomVoice( "voices_during_stroke" );
 
    if curLevel == 2 then
      
      nextAnim_1 = "anm_boss_fight_scr_clark_win_2";
      nextAnimFunc_1 = "clark_win2";
      
    elseif curLevel == 4 then 
      
      nextAnim_1 = "anm_boss_fight_scr_clark_win_2";
      nextAnimFunc_1 = "clark_win3";
      
    else 
      
      nextAnim_1 = "anm_boss_fight_scr_clark_win_2";
      nextAnimFunc_1 = "clark_win2";
      
    end;  
    
    nextAnim_2 = "anm_boss_fight_scr_our_hands_win";
    nextAnimFunc_2 = "win"; 
      
  else 
    
    --common_impl.PlayAudio( "sfx", "level3/sfx/aud_fight4", 0, "", 0 );
    
    nextAnim_1 = "anm_boss_fight_scr_clark_win_1";
    nextAnimFunc_1 = "clark_win1";
    nextAnim_2 = "anm_boss_fight_scr_our_hands_win";
    nextAnimFunc_2 = "win";  
      
  end;
  
  cmn.Lock( true );
  
  private.UpdateAnimTagSign();
  
  ObjMultiSet( { 
    { prevAnim_1,  { alp = 0 } },
    { prevAnim_2,  { alp = 0 } },
    { nextAnim_1,  { alp = 1 } },
    { nextAnim_2,  { alp = 1 } },
  } );

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_shot_amulet", 0, "", 0 );

  AnimPlay( nextAnim_1, nextAnimFunc_1, func_end );
  AnimPlay( nextAnim_2, nextAnimFunc_2, "" );
  
end;
--*******************************************************************************************************************
function private.UseAnim ( curLevel )
  
  local prevAnim_2 = "anm_boss_fight_scr_our_hands";
  local prevAnimFunc_2 = "arm";
  
  local nextAnim_2 = "";
  local nextAnimFunc_2 = "";
  
  local func_end = function ()
    
    if ( curLevel % 2 ~= 0 ) then 
      
      private.PlayRandomVoice( "voices_after_stroke" );
      
    end;
    
    ObjMultiSet( { 
      { prevAnim_2,  { alp = 1 } },
      { nextAnim_2,  { alp = 0 } },
    } );
   
    cmn.Lock( false );
    private.Update( true );
    private.UpdateAnimTag(); 
    private.StartAnimation();
    
  end;
  
  if ( curLevel % 2 == 0 ) then 
    
    --common_impl.PlayAudio( "sfx", "level3/sfx/aud_fight3", 0, "", 0 );
    private.PlayRandomVoice( "voices_during_stroke" );
    
    nextAnim_2 = "anm_boss_fight_scr_our_hands_sign";
    nextAnimFunc_2 = "sign";  
      
  else 
    
    --common_impl.PlayAudio( "sfx", "level3/sfx/aud_fight4", 0, "", 0 );

    nextAnim_2 = "anm_boss_fight_scr_our_hands_sign";
    nextAnimFunc_2 = "sign";  
    
  end;

  cmn.Lock( true );
  
  private.UpdateAnimTagSign();
  
  ObjMultiSet( { 
    { prevAnim_2,  { alp = 0 } },
    { nextAnim_2,  { alp = 1 } },
  } );
  
  AnimPlay( nextAnim_2, nextAnimFunc_2, func_end );
  
end;

--*******************************************************************************************************************
function private.WrongAnim ( curLevel )
  
  local prevAnim_1 = "anm_boss_fight_scr_clark1";
  local prevAnimFunc_1 = "clark1";  
  
  if curLevel == 2 then
    
    prevAnim_1 = "anm_boss_fight_scr_clark2";    
    prevAnimFunc_1 = "clark2";  
    
  elseif curLevel == 3 or
         curLevel == 4 then
    
    prevAnim_1 = "anm_boss_fight_scr_clark3";       
    prevAnimFunc_1 = "clark3";  
        
  end;  
  
  local prevAnim_2 = "anm_boss_fight_scr_our_hands";
  local prevAnimFunc_2 = "our_hands";
  
  local nextAnim_1 = "";
  local nextAnimFunc_1 = "";
  
  local nextAnim_2 = "";
  local nextAnimFunc_2 = "";
  
  local func_end = function ()
    
    if ( curLevel % 2 ~= 0 ) then 
      
      private.PlayRandomVoice( "voices_after_stroke" );
      
    end;
    
    if curLevel == 2 then
      
      prevAnim_1 = "anm_boss_fight_scr_clark2";    
      prevAnimFunc_1 = "clark2";  
      
    elseif curLevel == 3 or 
           curLevel == 4 then
      
      prevAnim_1 = "anm_boss_fight_scr_clark3";       
      prevAnimFunc_1 = "clark3";  
          
    end;   
    
    ObjMultiSet( { 
      { prevAnim_1,  { alp = 1, frame = 0, playing = true  } },
      { prevAnim_2,  { alp = 1  } },
      { nextAnim_1,  { alp = 0  } },
      { nextAnim_2,  { alp = 0  } },
    } );
    ObjAnimate( prevAnim_1, "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1  } );     
    ObjAnimate( nextAnim_1, "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0  } );   
    
    private.pair = { 0, 0, 0 }; 
    cmn.Lock( false );
    private.Update( true );
    private.UpdateAnimTag(); 
    
  end;
  
  if ( curLevel % 2 == 0 ) then

    --common_impl.PlayAudio( "sfx", "level3/sfx/aud_fight2", 0, "", 0 );
    private.PlayRandomVoice( "voices_during_stroke" );
    
    nextAnim_1 = "anm_boss_fight_scr_clark_loss";
    
    if curLevel == 2 then
      
      nextAnimFunc_1 = "clark_loss2";
      
    else
      
      nextAnimFunc_1 = "clark_loss3";
      
    end;  

    nextAnim_2 = "anm_boss_fight_scr_our_hands_loss";
    nextAnimFunc_2 = "loss";
      
  else

    --common_impl.PlayAudio( "sfx", "level3/sfx/aud_fight1", 0, "", 0 );
    
    nextAnim_1 = "anm_boss_fight_scr_clark_loss";
    nextAnimFunc_1 = "clark_loss1";
    
    nextAnim_1 = "anm_boss_fight_scr_clark_loss";    
    
    if curLevel == 1 then
      
      nextAnimFunc_1 = "clark_loss1";
      
    elseif curLevel == 2 then  
      
      nextAnimFunc_1 = "clark_loss2";
      
    else
      
      nextAnimFunc_1 = "clark_loss3";
      
    end;  
    
    nextAnim_2 = "anm_boss_fight_scr_our_hands_loss";
    nextAnimFunc_2 = "loss";

  end;

  ObjMultiSet( { 
    { prevAnim_1,  { alp = 0 } },
    { prevAnim_2,  { alp = 0 } },
    { nextAnim_1,  { alp = 1 } },
    { nextAnim_2,  { alp = 1 } },
  } );
  
  ObjAnimate( prevAnim_1, "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0  } );     
  ObjAnimate( nextAnim_1, "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1  } );    
  
  private.UpdateAnimTagSign();

  common_impl.PlayAudio( "sfx", "level3/sfx/aud_morrice_attack", 0, "", 0 );

  AnimPlay( nextAnim_1, nextAnimFunc_1, func_end );
  AnimPlay( nextAnim_2, nextAnimFunc_2, "" );  
  
end;


--*******************************************************************************************************************
function private.PlayRandomVoice ( voice )
  
  private.Randomseed();
  
  local voiceArray = private[ voice ];
  local newID = math.random( 1, #voiceArray );
  
  while ( newID == private.last_voice_id ) do   
  
    newID = math.random( 1, #voiceArray );
    
  end;
  
  private.last_voice_id = newID;
  common_impl.PlayAudio( "voc", "level3/voc/"..voiceArray[ newID ],  0, "", 0 );
  
end;

--*******************************************************************************************************************
function private.StopAllvoices ()
  
  for i = 1, private.VOICE_COUNT, 1 do 
    
    common_impl.StopAudio( "voc", "level3/voc/aud_fight_1_"..i.."_voc",  0.5 );
    
  end;
  
end;

--*******************************************************************************************************************
function private.IsItemFound ( level, item )

  local result = false;
  local foundItems = private.gamedata.found_items[ level ];

  for i = 1, #foundItems, 1 do
   
    if item == foundItems[ i ] then
      
      result = true;
      break;
      
    end;
    
  end;
  
  return result;
  
end;

--*******************************************************************************************************************
function private.StartTimer ()
 
  local func_end = function()
    
    private.StartTimer();
    
  end;
  
  local curLevel = private.gamedata.cur_level;
    
  if curLevel <= private.LEVEL_COUNT then
    
    private.timer_count = private.timer_count + 1;
    
    if private.timer_count <= private.time[ curLevel ] then  
      
      ObjSet( private.TIMER_NAME, { endtrig = func_end, time = 1, playing = true } ); 
      
    else
    
      private.StopTimer();
      
      cmn.Lock( true );
      
      private.gamedata.found_items[ curLevel ] = {};
      private.WrongAnim( curLevel ); 
      
    end;
    
  end;
  
end;


--*******************************************************************************************************************
function private.StopTimer ()
   
  local curLevel = private.gamedata.cur_level;
  private.timer_count = 0;
  ObjSet( private.TIMER_NAME, { playing = false } ); 
  ObjAnimate( "obj_boss_fight_scr_stage_"..curLevel, "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0  } );  
  ObjAnimate( "spr_boss_fight_scr_timer_interface", "alp",0,0, "", { 0, 0, 1,    0.3, 0, 0  } );  
  
end;


--*******************************************************************************************************************
function private.UpdateTimerInterface ()
    
  local curLevel = private.gamedata.cur_level;
  
  if curLevel % 2 == 0 then
    
    ObjSet( "spr_boss_fight_scr_field_2", { alp = 0 } );
    
  else
    
    ObjSet( "spr_boss_fight_scr_field_2", { alp = 1 } );
    
  end;
  
end;


--*******************************************************************************************************************
function private.UpdateAnimTag ()
   
  local curLevel = private.gamedata.cur_level;
  
  if curLevel == 2 then
  
    ObjMultiSet( { 
      { "anm_boss_fight_scr_clark1",  { alp = 0 } },
      { "anm_boss_fight_scr_clark2",  { alp = 1 } },
    } );
    
  elseif curLevel == 3 then
   
    ObjMultiSet( { 
      { "anm_boss_fight_scr_clark1",  { alp = 0 } },
      { "anm_boss_fight_scr_clark2",  { alp = 0 } },
      { "anm_boss_fight_scr_clark3",  { alp = 1 } },
    } );
    
  end; 
  
end;
--*******************************************************************************************************************
function private.UpdateAnimTagSign ()
  
  local curLevel = private.gamedata.cur_level;
  
  local func_end = function()  
    
    for i = 1,5 do
      
      ObjMultiSet( { 
        { "spr_boss_fight_scr_sign_arm_symbol"..i, { alp = 0 } },
        { "spr_boss_fight_scr_sign_symbol"..i,     { alp = 0 } },
      } );      
      
    end;    
    
  end;
  
   if curLevel == 1 then 
     
    local func_end_sign = function()
      
      func_end();
    
    end;    
    
    local sign = ObjGet( "obj_boss_fight_scr_sign" );
    local sign_arm = ObjGet( "obj_boss_fight_scr_sign_arm" );
    
    ObjAnimate( "obj_boss_fight_scr_sign", "alp",0,0, "", { 0, 0, sign.alp, 0.2, 0, 0  } );
    ObjAnimate( "obj_boss_fight_scr_sign_arm", "alp",0,0, "", { 0, 0, sign_arm.alp, 0.2, 0, 0   } );
    ObjAnimate( "obj_boss_fight_scr_anim", "alp",0,0, func_end_sign, { 0, 0, 1, 0.2, 0, 1 } );
     
   elseif curLevel == 2 then
    
    local func_end_sign = function()
      
      func_end(); 
      
      if ( private.sign ~= 5 ) then
        
        ObjMultiSet( { 
          { "spr_boss_fight_scr_sign_arm_symbol"..private.sign, { alp = 1 } },
          { "spr_boss_fight_scr_sign_symbol"..private.sign,     { alp = 1 } },
        } ); 
      
      end;
    
    end;    
    
    local sign = ObjGet( "obj_boss_fight_scr_sign" );
    local sign_arm = ObjGet( "obj_boss_fight_scr_sign_arm" );
    
    ObjAnimate( "obj_boss_fight_scr_sign", "alp",0,0, "", { 0, 0, sign.alp, 0.2, 0, 0, 0.4, 0, 1,   } );
    ObjAnimate( "obj_boss_fight_scr_sign_arm", "alp",0,0, "", { 0, 0, sign_arm.alp, 0.2, 0, 0, 0.4, 0, 1,   } );
    ObjAnimate( "obj_boss_fight_scr_anim", "alp",0,0, func_end_sign, { 0, 0, 1, 0.2, 0, 1 } );
    
  elseif curLevel == 3 then
    
    local func_end_sign = function()
      
      func_end(); 

    end;    
    
    local sign = ObjGet( "obj_boss_fight_scr_sign" );
    local sign_arm = ObjGet( "obj_boss_fight_scr_sign_arm" );
    
    ObjAnimate( "obj_boss_fight_scr_sign", "alp",0,0, "", { 0, 0, sign.alp, 0.2, 0, 0  } );
    ObjAnimate( "obj_boss_fight_scr_sign_arm", "alp",0,0, "", { 0, 0, sign_arm.alp, 0.2, 0, 0  } );
    ObjAnimate( "obj_boss_fight_scr_anim", "alp",0,0, func_end_sign, { 0, 0, 1, 0.2, 0, 1 } );
    
  elseif curLevel == 4 then
    
    local func_end_sign = function()
      
      func_end(); 

      if ( private.sign == 5 ) then
        
        ObjMultiSet( { 
          { "spr_boss_fight_scr_sign_arm_symbol"..private.sign, { alp = 1 } },
          { "spr_boss_fight_scr_sign_symbol"..private.sign,     { alp = 1 } },
        } ); 
      
      end;
    
    end;    
    
    DbgTrace( "Сигна в 4 уровне" );     
    private.sign = 5;    
    
    local sign = ObjGet( "obj_boss_fight_scr_sign" );
    local sign_arm = ObjGet( "obj_boss_fight_scr_sign_arm" );
    
    ObjAnimate( "obj_boss_fight_scr_sign", "alp",0,0, "", { 0, 0, sign.alp, 0.2, 0, 0, 0.4, 0, 1,   } );
    ObjAnimate( "obj_boss_fight_scr_sign_arm", "alp",0,0, "", { 0, 0, sign_arm.alp, 0.2, 0, 0, 0.4, 0, 1,   } );
    ObjAnimate( "obj_boss_fight_scr_anim", "alp",0,0, func_end_sign, { 0, 0, 1, 0.2, 0, 1 } );
    
  end; 
  
end;

--*******************************************************************************************************************
function private.UpdateLiquid ()

  local curLevel = private.gamedata.cur_level;
  
  ObjAnimate( "obj_boss_fight_scr_stage_"..curLevel, "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );  
  ObjAnimate( "spr_boss_fight_scr_timer_interface", "alp",0,0, "", { 0, 0, 0,    0.3, 0, 1 } );  

end;


--*******************************************************************************************************************
function private.Randomseed()
  
  math.randomseed( os.time() );
  
  for i = 1, os.time() % 100, 1 do
    math.random();
  end;
  
end;
  
--*******************************************************************************************************************
function private.AnimationShuffle( animID )

  local time = math.random( 50, 100 );
  local dead = math.random( 5, 50  );
  local posx = math.random( 5, 15  );
  local posy = math.random( 5, 25  );
  local ghostx = math.random( 5, 5 );
  local ghosty = math.random( 5, 5 );
  local fixght = 0.2
  local sprfull  = string.sub( animID, 5 );
  local spr  = "spr_"..sprfull;
  local ghost = spr.."_ghost";
  local curRes = ObjGet( spr );
  
  ObjAnimate( animID, "pos_xy",1,1, "",
  { 0, 0, 0, 0, 
    time/dead, 3, posx, posy, 
    (time*2)/dead, 3, -posx, -posy, 
    (time*3)/dead, 0, 0, 0, 
  } );
  
  if ObjGet( spr ) then  
    
    ObjCreate( ghost, "spr" );    
    ObjAttach( ghost, animID );   
    ObjSet( ghost,
    {
      alp = 0.3,
      input = false,
      res = curRes.res,
      pos_z = -5,
      scale_x = 1.2, 
      scale_y = 1.2,
    } );
    
    ObjAnimate( ghost, "pos_xy",1,1, "",
    { 0, 0, 0, 0, 
      fixght+( time/dead ), 3, -ghostx, -ghosty, 
      fixght+((time*2)/dead), 3, ghostx, ghosty, 
      fixght+((time*3)/dead), 0, 0, 0, 
    } );
  
  end;

end;

--*******************************************************************************************************************
function private.Update ( isNeedStartTimer )
  
  local curLevel = private.gamedata.cur_level; 
  
  if isNeedStartTimer then
    
    private.StartTimer();
    private.UpdateLiquid();

  end;
  
  ObjSet( "obj_int_taskpanel", { alp = 0, visible = false } )

  private.LogicInit();
  
  if ( isNeedStartTimer and 
  curLevel > private.LEVEL_COUNT ) then
    
    private.Win();
    
  end;
  
end;


--*******************************************************************************************************************
function private.Win () 
 
  local func_end = function()
    
    cmn.SetEventDone( "win_boss_fight_scr" );
    cmn.CallEventHandler( "win_boss_fight_scr" );

    cmn.Lock( false );
    levelscr.ExitMG();
  
    ObjAnimate( "mg_boss_fight_scr", "color_rgb",0,0, "", { 0, 0, 1, 1, 1,    0.3, 0, 0, 0, 0 } );
    
  end; 
  
  private.StopTimer(); 

  common_impl.PlayAudio( "sfx", "aud_win_mg" );
  
  cmn.MiniGameHide();
  cmn.Lock( true );
  
  ObjAnimate( "obj_boss_fight_scr_areas", "alp",0,0, func_end, { 0, 0, 1,    0.3, 0, 0,    1, 0, 0 } );
  
end;

--*******************************************************************************************************************
function private.StartAnimation () 
  
  local curLevel = private.gamedata.cur_level; 
  
  ObjAnimate( "obj_boss_fight_scr_areas", "alp",1,0, "", { 0, 0, 1,    1, 0, 0.7,    2, 0, 1,   3, 0, 1 } );
  
    if curLevel == 1 then
      
      for j = 1, 4 do
        
        for k = 1, 2 do
       
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";

            if ( not private.IsItemFound( curLevel, curArea ) ) then
              
              private.AnimationShuffle( curArea );
                                 
            end;
        
        end;
                          
      end;
                          
    elseif curLevel == 2 then   
     
      for j = 1, 4 do
        
        for k = 1, 3 do
        
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";
          
            if ( not private.IsItemFound( curLevel, curArea ) ) then
              
              private.AnimationShuffle( curArea );
                                 
            end;
          
        end;
                          
      end;   
                            
    elseif curLevel == 3 then   
     
      for j = 1, 7 do
        
        for k = 1, 2 do
        
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";
          
            if ( not private.IsItemFound( curLevel, curArea ) ) then
              
              private.AnimationShuffle( curArea );
                                 
            end;
          
        end;
                          
      end;      
                            
    elseif curLevel == 4 then   
     
      for j = 1, 12 do
        
        for k = 1, 3 do
          
          local curArea = private.AREA_NAME..curLevel.."_"..j.."_"..k;
          local curSprArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k;
          local curLightArea = private.AREA_LIGHT_NAME..curLevel.."_"..j.."_"..k.."_light";   
          
            if ( not private.IsItemFound( curLevel, curArea ) ) then
              
              private.AnimationShuffle( curArea );
                                 
            end;
          
        end;
                          
      end;   
                            
    end;
  
end;

--*********************************************************************************************************************
function public.Reset ()

  local curLevel = private.gamedata.cur_level;
  private.last_icon_position = 0;
  private.StopTimer();
  
  private.Default(); 
  private.Load();
  
  private.StopAllvoices(); 

end; 

--*********************************************************************************************************************
function public.Skip ()

  private.StopTimer(); 
  private.gamedata.cur_level = 5;
  ObjMultiSet( { 
    { "anm_boss_fight_scr_clark1",  { alp = 0 } },
    { "anm_boss_fight_scr_clark2",  { alp = 0 } },
  } );

  private.Update( false ); 
  private.RightAnim ( 4 );
  private.StopAllvoices(); 
  
end;








